
options fullstimer;
options BUFSIZE=32k BUFNO=2k;
options compress=yes;
libname tau "V:\DG75-GD3E\DMSE\Petrole\Sources donnees\tables demo";
libname libbase "V:\DG75-GD3E\DMSE\Petrole\Sources donnees\CCFA\donnes brutes";
libname petrole "V:\DG75-GD3E\DMSE\Petrole\tables travail";
/*Input Table :
- immat : libbase.neuf200&an.
- incomes and urban areas : tau.revenus et tau.tab_tau*/
/*Output Table petrole.neuf200&andemo :
car registrations with demographic characteristics*/

/*See code NAF http://www.rouen.cci.fr/outils/ape/homepage.asp*/


proc format;
/*voir code NAF http://www.rouen.cci.fr/outils/ape/homepage.asp*/
value $ape 
"00"-"44"='A'/*agric+industrie+btp;*/
"45"-"45"='B'/* commerce et repara autom; */
"46"-"48","49"-"54","55"-"76","78"-"99"='C'/*commerce et services*/
/*"49"-"54","55"-"76","78"-"99"='D'services; */
"77"-"77"='E' /*location et loc bail*/ 
;
run;
 option mprint;

 
%macro construction_table; 
/*Income quantiles*/
proc univariate data=tau.revenus  ;var rev_ens ;
output out=Pctls pctlpts= 50 to 100 by 50 pctlpre=Pct_ ;run;


/* Import of Urban Size and income by cities*/
data pop_comm;
	set tau.tab_tau(keep=codgeo ZAUER1999);
	/* recodage of  Zip Codes for  Paris Lyon Marseilles */
	length comm_insee 8.;
	depart=substr(codgeo,1,2);comm_insee=substr(codgeo,3,3);
	if depart = "13" and comm_insee=55 then do;
		do i=201 to 216;
			comm_insee= i;
			output;
		end;
	end;
	else do;
		if depart = "69" and comm_insee=123 then do;
			do i=381 to 389;
			comm_insee= i;
				output;
			end;
		end;
		else do;
			if depart = "75" and comm_insee=56 then do;
				do i=101 to 120;
			comm_insee= i;
					output;
				end;
			end;
			else do;
				if depart ne "" then output;
			end;
		end;
	end;
	drop i;
run;

proc sort data=pop_comm;
by depart comm_insee;
run;
 
proc sort data=tau.revenus;
by depart comm_insee;
run;
 
data demo;
	merge pop_comm(in=a)  tau.revenus(in=b);
	by depart comm_insee;
	if a and b;
run;


%do an=3 %to 7;
data neuf0&an.temp;
	set libbase.neuf200&an.;
	/* Commune de Lomme rattache  Lille */
	if depart = "59" and comm_insee = 355 then comm_insee = 350;
	/* Commune de Guitalens... */
	if depart = "81" and comm_insee = 107 then comm_insee = 120;
run;



proc sort data=neuf0&an.temp;by depart comm_insee;
run;

data neuf0&an.demo;
	merge neuf0&an.temp(in=a) demo; 
	by depart comm_insee;
	if a;
 	if c_s_p ne '' then prof=(c_s_p < "A1"); 
	if (c_s_p >="A1")  then do;
			age_num = 200&an - an_naiss_pro;
			tr_rev_num = 1 ;
	/*on garde cette segmentation  cause des filtres ( discuter?);
	/* Variable d'activit */  
			if (age_num = . or age_num<65) and c_s_p="Z1" then delete;/*Z1 :  missing variable for occupation*/
			else do; 
			if age_num >= 65 or c_s_p in ("L1","M1","N1","P1") then actif = '0' ;
			else 
				if age_num <30 then actif = '1'; 
                if age_num >=30 then actif = '2'; 
			end;
	end; 

	/*Code commune IdF*/
	if depart in("75", "77", "78", "91", "92", "93", "94", "95") then idf = 1 ; else idf = 0;

    /*Code de la catgorie de la commune dans les aires et espaces urbains 1999 (ZAUER)*/
 /* typologie en 4 classes pour les zones urbaines*/ 
	if idf = 1 then do ; 
		if ZAUER1999 ='1' then do ; tu='0'; zone="0"; end ; /*urbain en IdF*/
		if ZAUER1999 ='2' then do ; tu='1'; zone="1"; end ; /*monopolarisee en IdF*/
		end ; 
	else do ; 
		if ZAUER1999 ='1' then do ; tu='2'; zone="2"; end ; /*urbain hors IdF*/
		if ZAUER1999 ='2' then do ; tu='3'; zone="3"; end ; /*monopolarisee hors IdF, multipolarisee, rural*/
    end ; 
	if ZAUER1999 in ('3','4','5','6') then do ; tu='3'; zone="3";  end ; /*monopolarisee hors IdF, multipolarisee, rural*/
 
drop an_naiss_pro  ZAUER1999;
run; 
	%do i=1 %to 1;
		%let pct=%eval(50*&i);
			data _null_;set Pctls; 
			call symput("revq",pct_&pct);

			data neuf0&an.demo;
			set neuf0&an.demo;
	if (c_s_p >="A1") and zone not in  ('0','1')  then do;
			/* Revenus mdians des individus dans la commune ayant la mme tranche d'ge */
                    if age_num ne . and rev_30 ne . then do;
					if age_num < 30 then tr_rev_num = 1 +(rev_30>=&revq.); 
					if age_num >= 30 and age_num<=39 then tr_rev_num = tr_rev_num +(rev_30_39>=&revq.); 
					if age_num >= 40 and age_num<=49 then tr_rev_num = tr_rev_num +(rev_40_49>=&revq.); 
					if age_num >= 50 and age_num<=59 then tr_rev_num = tr_rev_num +(rev_50_59>=&revq.); 
					if age_num >= 60 and age_num<=74 then tr_rev_num = tr_rev_num +(rev_60_74>=&revq.); 
					if age_num >= 75 then tr_rev_num =tr_rev_num +(rev_75>=&revq.); 
					end;
					else do;
						if rev_ens ne . then tr_rev_num = tr_rev_num +(rev_ens>=&revq.); 
						else delete;
					end;
		end;	
		/*Pour l'ile de France on ne fait pas la distinction par revenu de la commune*/
		/*car essentiellement communes riches*/ 
	if (c_s_p >="A1") and zone in  ('0','1') then tr_rev_num=0;
			run;
	%end;



proc freq data=neuf0&an.demo(where=(prof=1)) ;
table zone  ; 
run ; 
 
data petrole.neuf0&an.demo;
set neuf0&an.demo;
	length tr_rev $1.;
	tr_rev = put(tr_rev_num,$1.);	
	if prof then ape=put(c_s_p,$ape.);
	/* Variable dmographique = Tranche de revenu 
	(on garde car utile d'avoir qqchose lexiquement cohrent avec le reste  */
 
length demo $7.; 
if (c_s_p >="A1") then demo =compress(prof||"_"||zone||"_"||actif||"_"||left(tr_rev));
else  demo =compress(prof||"_"||zone||"_"||left(ape));

if zone ne '';
run;

proc freq data=petrole.neuf0&an.demo(where=(prof=1)) ;
table zone demo; 
run ;  


%end; 
%mend;
%construction_table;     
   
proc freq data=petrole.neuf04demo(where=(prof=1)) ;
table zone; 
run ; 
 
proc freq data=petrole.neuf04demo(where=(prof=0)) ;
table zone; 
run ; 
 
proc freq data=petrole.neuf04demo(where=(prof=0)) ;
table actif; 
run ; 
 
 
proc freq data=petrole.neuf04demo(where=(prof=0)) ;
table actif; 
run ; 
 
