options fullstimer;
options BUFSIZE=32k BUFNO=2k;
options compress=yes ;

libname segment "V:\DG75-GD3E\DMSE\Petrole\Sources donnees\segment";
libname petrole "V:\DG75-GD3E\DMSE\Petrole\tables travail";
/*Input Data : 
- vehicles by segment segment.monospaces segment.liste4_4 segment.utilitaires segment.citadines
segment.sports segment.compactes 
- All car registration with demographic characteristics  petrole.neuf0andemo 
- fuel price and cpi : petrole.prixessence petrole.cpi */
/*Output Data: petrole.total */
 

/* citadines : */
/* compactes : */
/* Grandes routires : */
/* Monospaces : */
/* Voitures de sport : carrosserie_cg = cabr ou (ci et ptr / puis_kw < 17.5 et ptr < 2000 */
/* 4x4 : liste */



proc sort data=segment.sports;
	by marque modele nb_pl_ass;
run;

proc sort data=segment.liste4_4;
	by marque modele;
run;

proc sort data=segment.utilitaires;
	by marque modele;
run;

proc sort data=segment.monospaces;
	by marque modele;
run;

proc sort data=segment.citadines;
	by marque modele;
run;

proc sort data=segment.compactes;
	by marque modele;
run;
%macro segmentation(an);

data neuf&an.;
	set petrole.neuf&an.demo;
	if puis_kw < 999 and ptr<99999 then rapport = ptr/puis_kw;
	if modele="DIVERS" then delete;
	if marque="QUATTRO" then marque = "AUDI";
	length segment $8;
	segment = "BERLINE";
	if carrosserie_cg = "CABR" or (carrosserie_cg = "CI" and (rapport< 13 or (rapport < 17.5 and ptr < 2000))) 
	then segment = "SPORT";
run;

proc sort data=neuf&an.;
	by marque modele nb_pl_ass;
run;

data neuf&an.;
	merge neuf&an.(in=a) segment.sports(in=b);
	by marque modele nb_pl_ass;
	if b=1 then segment = "SPORT";
run;

proc sort data=neuf&an.;
	by marque modele;
run;

data neuf&an.;
	merge neuf&an.(in=a) segment.liste4_4(in=b) segment.utilitaires(in=c) segment.monospaces(in=d) segment.citadines(in=e) 
	segment.compactes(in=f) ;
	by marque modele;
	if a ;
	if b=1 then segment = "TT-TERR"; 
	if c=1 then segment = "UTILIT";
	if d=1 then segment = "MONOSP";
	if e=1 then segment = "CITADINE";
	if f=1 then segment = "COMPACTE";
	if nb_pl_ass = 7 and segment = "UTILIT" then segment = "MONOSP";
	/* On retrouve la mgane scenic " la louche", suivant le poids */ 
	if marque = "RENAULT" and modele = "MEGANE" and nb_portes = 5 and nb_pl_ass>=5
	/*and ((ptr > 1800 and energie="ESSENCE") or (ptr>1880 and energie="GAZOLE"))*/ then segment = "MONOSP";
run;

data neuf&an.;
	set neuf&an.;
	annee = 20&an.;
run;

%mend;  
%segmentation(03)
%segmentation(04)
%segmentation(05)
%segmentation(06)
%segmentation(07)
/*%segmentation(08)*/ 
option mprint;

proc format;
 value nbportes
2,4,6,9="Others"
3="3"
5="5"
;
value classeco
1-100='A'
101-120='B'
121-140='C'
141-160='D'
161-200='E'
201-250='F'
251-998='G';
value classpuis
1-60='1'
61-100='2'
101-140='3'
141-180='4'
181-998='5' ;
run; 


data total ;
set neuf03 neuf04 neuf05 
neuf06 neuf07 /*petrole.neuf08*/ ;
/*exclusion des valeurs aberrantes (155 obs avec Co2=999) , 6 lignes avec prix 999999999 et modeles aberrants*/
	where energie in ('ESSENCE','GAZOLE') and CO2 <999 
		and carrosserie_cg not in ('TC',' NON SPEC',' DERIV VP' )
and marque not in ('DIV FRANCE',' DIV G.B.') and PRIX_VEHIC <99999999 ;
	format date_new mmyys7.;
	date_new = mdy(substr(date,5,2),"01",substr(date,1,4));
	annee=year(date_new);
	mois =month(date_new); 

/*regroupement de variables en classes*/
classCo2=put(CO2,classeco.);
classpuis=put(PUIS_KW,classpuis.); 
/*rappel code demo
if (c_s_p >="A1") then demo =compress(prof||"_"||zone||"_"||actif||"_"||left(tr_rev));
else  demo =compress(prof||"_"||zone||"_"||left(ape)); */
keep date_new annee mois demo marque  modele segment co2 energie  classCo2 classpuis PUIS_KW
volume nb_portes carrosserie_cg PRIX_VEHIC zone actif tr_rev_num ape poids_vide;
run ;  

/*stat des caracteristiques acheteurs*/

/*professionnels*/
proc freq data= total ;
table ape ; 
run;
proc freq data= total(where=(ape ne ''))  ;
table zone  ; 
run;

/*particuliers*/
proc freq data= total  ;
table tr_rev_num actif ; 
run;

proc freq data= total(where=(ape = ''))  ;
table zone ; 
run;


 
/*calcul du prix aux 100 km*/
proc sort data=total;by annee mois;

/*table rcupre sur le site 
http://www.developpement-durable.gouv.fr/energie/petrole/se_cons_fr.htm */

/*data petrole.prixessence;set prixessence(rename=( log_Super98_3m=Super98_lag3m 
log_gazole_3m=gazole_lag3m));
keep annee mois Super98_lag3m gazole_lag3m  Super_SP98_TTC gazole_TTC;run;
proc sort data= petrole.prixessence;by annee mois;*/

/*dflateur IPC : voir programme Helene make_data_allg1.do */
/* reference =200801 cpi(date)=ipc(200801)/ipc(date)*/
proc sort data= petrole.defcpi;by annee mois;
 
data petrole.total;merge total (in=e )
 petrole.prixessence  
petrole.defcpi	;
format nbporte3 nbporte5 claspuis1-claspuis5 clasco0-clasco6   3.;
by annee mois; 
if e;  

/*cls de passage issues Ademe */
/*prix  la tonne insee ; Masse vol gazole= 0.845 essence=0.755 kg/l*/
if energie="ESSENCE" then do;
		conso=co2*0.043; 
		prixkilom=conso*Super_SP98_TTC/100;
		prixkilomdef=conso*Super_SP98_TTC*cpi/100; 
		prixkilomlag3m=conso*Super98_lag3m*cpi/100; 
		end;
if energie="GAZOLE" then do; 
		conso=co2*0.038;
		prixkilom=conso*gazole_TTC/100;
		prixkilomdef=conso*gazole_TTC*cpi/100;
		prixkilomlag3m=conso*gazole_lag3m*cpi/100; end;
prixgazoledef=gazole_TTC*cpi;
prixsuperdef=Super_SP98_TTC*cpi;
prix=PRIX_VEHIC*cpi;

array claspuis[5] claspuis1-claspuis5;
do i=1 to 5;
 claspuis[i]=(classpuis=i);
end;
nbporte3=(nb_portes=3);
nbporte5=(nb_portes=5);

clasco0=(classCo2='A');
clasco1=(classCo2='B');
clasco2=(classCo2='C');
clasco3=(classCo2='D');
clasco4=(classCo2='E');
clasco5=(classCo2='F');
clasco6=(classCo2='G');

run;
proc freq data=petrole.total;tables demo segment;run;

/*



                                                                        Frquence    Pctage
                                demo       Frquence     Pourcentage     cumule      cumul
                                
                                0_0_0_0       39770          0.57          39770       0.57
                                0_0_1_0      184602          2.65         224372       3.23
                                0_0_2_0      485317          6.98         709689      10.20
                                0_1_0_0       11002          0.16         720691      10.36
                                0_1_1_0       44906          0.65         765597      11.01
                                0_1_2_0       81753          1.18         847350      12.18
                                0_2_0_1      144490          2.08         991840      14.26
                                0_2_0_2       81520          1.17        1073360      15.43
                                0_2_1_1      380934          5.48        1454294      20.91
                                0_2_1_2      191156          2.75        1645450      23.66
                                0_2_2_1      676984          9.73        2322434      33.39
                                0_2_2_2      644710          9.27        2967144      42.66
                                0_3_0_1      135522          1.95        3102666      44.61
                                0_3_0_2      115871          1.67        3218537      46.27
                                0_3_1_1      245528          3.53        3464065      49.80
                                0_3_1_2      329973          4.74        3794038      54.55
                                0_3_2_1      449918          6.47        4243956      61.02
                                0_3_2_2      563996          8.11        4807952      69.13
                                1_0_A         87712          1.26        4895664      70.39
                                1_0_B        120523          1.73        5016187      72.12
                                1_0_C        131192          1.89        5147379      74.01
                                1_0_E        121395          1.75        5268774      75.75
                                1_1_A          6734          0.10        5275508      75.85
                                1_1_B         12003          0.17        5287511      76.02
                                1_1_C         10817          0.16        5298328      76.18
                                1_1_E          2955          0.04        5301283      76.22
                                1_2_A        201335          2.89        5502618      79.11
                                1_2_B        645220          9.28        6147838      88.39
                                1_2_C        279665          4.02        6427503      92.41
                                1_2_E        193099          2.78        6620602      95.19
                                1_3_A         97518          1.40        6718120      96.59
                                1_3_B        115204          1.66        6833324      98.25
                                1_3_C        113240          1.63        6946564      99.87
                                1_3_E          8781          0.13        6955345     100.00


                                                                         Frquence    Pctage
                                segment     Frquence     Pourcentage     cumule      cumul
                                
                                BERLINE      1939318         27.88        1939318      27.88
                                CITADINE      460653          6.62        2399971      34.51
                                COMPACTE     2183104         31.39        4583075      65.89
                                MONOSP       1456988         20.95        6040063      86.84
                                SPORT         258443          3.72        6298506      90.56
                                TT-TERR       389810          5.60        6688316      96.16
                                UTILIT        267029          3.84        6955345     100.00
*/


proc sql;
create table temp  as select sum(volume) as tot 
from petrole.total
group by demo ;

