options fullstimer;
options BUFSIZE=32k BUFNO=2k;
options compress=yes ;
libname tau "V:\DG75-GD3E\DMSE\Petrole\Sources donnees\tables demo";
libname petrole "V:\DG75-GD3E\DMSE\Petrole\tables travail";

/*For costs shifters instruments*/
/*Input Table : donnees_export et indices_import_caoutch_fer 
/*obtained from BDM (as provided by N. Devillard, div IPPI)*/
/*Output Table : tau.indices_utiles*/
data temp;set tau.donnees_export
(keep=activity valeur annee mois 
where=(activity in ('2211','241','293','291','292') 
and annee>'2001' and annee<'2008'));
run;
proc sort data=temp;by annee mois;
proc transpose data=temp out=indices_utiles
delim=activity prefix=indic;
by annee mois;
run;
data indices_utiles_t; set indices_utiles 
(keep= annee mois indic1-indic5) ;
rename indic1=indic241
indic2=indic291 
indic3=indic292
indic4=indic293
indic5=indic2211;
annee2=annee*1;
mois2=mois*1;
drop annee mois;
rename annee2=annee mois2=mois;
run; 
data temp2;set tau.indices_import_caoutch_fer
(where=(ann_e>2001 and ann_e<2008));
rename ann_e=annee;run; 


data indices_utiles;
merge indices_utiles_t temp2;
by annee mois;run;
proc sort data=indices_utiles;by mois annee;run;

data indices_utiles2;set indices_utiles;
retain indic241  indic291 indic292 indic293 indic2211 caoutchouc fer;
by mois annee;
l_indic241=lag(indic241);
l_indic291=lag(indic291);
l_indic292=lag(indic292);
l_indic293=lag(indic293);
l_indic2211=lag(indic2211);
l_fer=lag(fer);
l_caoutchouc=lag(caoutchouc); 
run;
data tau.indices_utiles;set indices_utiles2;where annee>2002;run;
proc sort data=tau.indices_utiles;by annee mois;run;
