options fullstimer;
options BUFSIZE=32k BUFNO=2k;
options compress=yes ;
/*For instrument calculations */
libname petrole "V:\DG75-GD3E\DMSE\Petrole\tables travail";
libname petrole2 "U:\Petrole\Tables travail";
libname tau "U:\Petrole\Sources donnees\tables demo";

/*Input data: petrole.total (ensemble des immat), tau.indice_utiles (court mat premiere)*/

/*Output data: petrole2.instrumenttvared (ancienne table petrole2.instrument archiv en local)*/

/*Calculation of all instruments : costshifters and BLP*/
/*filtre : on supprime les modeles seuls de leur marque dans un segment*/
/*concerne environ 2000 obs sur 30000*/ 


/*Model : marque*modele*segment*energie*/
 option mprint;


proc sort data= petrole.total ; by annee mois;
%macro pourinstrument; 
data pourinstrument;merge petrole.total tau.indices_utiles; by annee mois;
gasole=(energie='GAZOLE');

/*poids_vide exprime en kg, on rapporte en tonne _t pour temporaire*/

cs_caoutch_t=poids_vide*caoutchouc/1000;
cs_fer_t=poids_vide*fer/1000;/*
cs_2211_t=poids_vide*indic2211/1000;
cs_241_t=poids_vide*indic241/1000;
cs_292_t=poids_vide*indic292/1000;
cs_293_t=poids_vide*indic293/1000;*/

cs_lcaoutch_t=poids_vide*l_caoutchouc/1000;
cs_lfer_t=poids_vide*l_fer/1000;/*
cs_l2211_t=poids_vide*l_indic2211/1000;
cs_l241_t=poids_vide*l_indic241/1000; 
cs_l292_t=poids_vide*l_indic292/1000;
cs_l293_t=poids_vide*l_indic293/1000;*/

/*deductible VAT for businesses*/
if (substr(left(demo),1,1)='1') and (energie='GAZOLE') then prixkilomlag3m_m=prixkilomlag3m_m*1.0392/1.196;
  

run;  
 

proc sql;
/* 1 modle = marque*modele*segment*energie */
create table model as
		select distinct mois, annee, 
		marque, modele, segment, energie  
		from pourinstrument
order by annee, mois,marque, modele, segment, energie ;  
   


/*costshifters*/ 

create table costshifters as
		select distinct mois, annee, 
			marque, modele, segment, energie ,
 	
		    sum(volume*cs_caoutch_t)/sum(volume) as cs_caoutch,
			sum(volume*cs_fer_t)/sum(volume) as cs_fer,/*
			sum(volume*cs_2211_t)/sum(volume) as cs_2211,
			sum(volume*cs_241_t)/sum(volume) as cs_241, 
			sum(volume*cs_292_t)/sum(volume) as cs_292,
			sum(volume*cs_293_t)/sum(volume) as cs_293,*/
			sum(volume*cs_lcaoutch_t)/sum(volume) as cs_lcaoutch,
			sum(volume*cs_lfer_t)/sum(volume) as cs_lfer/*,
			sum(volume*cs_l2211_t)/sum(volume) as cs_l2211,
			sum(volume*cs_l241_t)/sum(volume) as cs_l241, 
			sum(volume*cs_l292_t)/sum(volume) as cs_l292,
			sum(volume*cs_l293_t)/sum(volume) as cs_l293*/
	
		    ,sum(cs_caoutch_t)/sum(1) as cs_caoutchnp,
			sum(cs_fer_t)/sum(1) as cs_fernp,/*
			sum(cs_2211_t)/sum(1) as cs_2211np,
			sum(cs_241_t)/sum(1) as cs_241np, 
			sum(cs_292_t)/sum(1) as cs_292np,
			sum(cs_293_t)/sum(1) as cs_293np,*/
			sum(cs_lcaoutch_t)/sum(1) as cs_lcaoutchnp,
			sum(cs_lfer_t)/sum(1) as cs_lfernp/*,
			sum(cs_l2211_t)/sum(1) as cs_l2211np,
			sum(cs_l241_t)/sum(1) as cs_l241np, 
			sum(cs_l292_t)/sum(1) as cs_l292np,
			sum(cs_l293_t)/sum(1) as cs_l293np*/

		from pourinstrument group by mois, annee, marque, 
		modele, segment, energie  
		order by annee,mois, 
			marque, modele, segment, energie
;   
create table dieselcostshift as select distinct * from costshifters where energie="GAZOLE";
create table supercostshift as select distinct * from costshifters where energie="ESSENCE";


create table diff_costshift as select distinct a.annee,a.mois,a.marque,a.modele,a.segment,
			a.cs_caoutchnp-b.cs_caoutchnp as diff_cs_caoutch,
			a.cs_fernp-b.cs_fernp as diff_cs_fer,/*
			a.cs_2211np-b.cs_2211np as diff_cs_2211 , 
			a.cs_241np-b.cs_241np as diff_cs_241 , 
			a.cs_292np-b.cs_292np as diff_cs_292 , 
			a.cs_293np-b.cs_293np as diff_cs_293 , */
			a.cs_lcaoutchnp-b.cs_lcaoutchnp as diff_cs_lcaoutch,
			a.cs_lfernp-b.cs_lfernp as diff_cs_lfer/*,
			a.cs_l2211np-b.cs_l2211np as diff_cs_l2211 , 
			a.cs_l241np-b.cs_l241np as diff_cs_l241 , 
			a.cs_l292np-b.cs_l292np as diff_cs_l292 , 
			a.cs_l293np-b.cs_l293np as diff_cs_l293 */
			from dieselcostshift a ,supercostshift b where 
		  a.annee=b.annee and a.mois=b.mois 
		and a.segment=b.segment and a.marque=b.marque 
		and a.modele=b.modele 
 order by a.annee, a.mois,a.marque, a.modele, a.segment;  
 


create table temp as
		select distinct mois, annee, 
			marque, modele, segment, energie , 
			/*attention on somme : ncessaire pour les instruments BLP en SOMME*/
			/*pourinstrument comprend en effet plus de lignes que marque modele segment energie*/
			/*il faut en tenir compte si on fait des moyennes (utiliser vol_modenerg)*/
			sum(1) as vol_modenerg,
			sum(nbporte3)  as nbporte3b,
			sum(nbporte5)  as nbporte5b,
			sum(prixkilomlag3m)  as prixkilomlag3mb,  
			sum(cs_caoutch_t) as cs_caoutch_tb,
			sum(cs_lcaoutch_t) as cs_lcaoutch_tb,
			sum(cs_fer_t) as cs_fer_tb,
			sum(cs_lfer_t) as cs_lfer_tb,
			gasole  ,
			sum(puis_kw)  as puis_kwb
			%do i=1 %to 5 ;, 
			sum(volume*claspuis&i.)/sum(volume) as  claspuis&i.b  
			%end; 
			%do i=0 %to 6 ;, 
			 sum(clasco&i.) as  clasco&i.b
			%end;  

		from pourinstrument 
		group by annee,mois,  marque, modele, segment, energie  
		order by annee,mois,  marque, modele, segment, energie   
;  
/*pour la part de diesel dans le model*/
create table diesel as select distinct * from temp where gasole=1;
create table super as select distinct * from temp where gasole=0;

 
/*pour les diffrences entre les deux modles on compare moyenne par modele*/
create table diff_energie as select distinct a.annee,a.mois,a.marque,a.modele,a.segment,
			a.nbporte3b/a.vol_modenerg-b.nbporte3b/b.vol_modenerg as diff_nbporte3,
			a.nbporte5b/a.vol_modenerg-b.nbporte5b/b.vol_modenerg as diff_nbporte5,
			a.prixkilomlag3mb/a.vol_modenerg-b.prixkilomlag3mb/b.vol_modenerg as diff_prixkilomlag3m /*virgule enleve ici*/
			%do i=1 %to 5 ;, 
			a.claspuis&i.b-b.claspuis&i.b as diff_claspuis&i.
			%end;,/*virgule ajoute ici*/
			a.puis_kwb/a.vol_modenerg-b.puis_kwb/b.vol_modenerg as diff_puis_kw  
			%do i=0 %to 6 ;,
			a.clasco&i.b/a.vol_modenerg-b.clasco&i.b/b.vol_modenerg as diff_clasco&i.
			%end; 
			from diesel a ,super b where 
		  a.annee=b.annee and a.mois=b.mois 
		and a.segment=b.segment and a.marque=b.marque 
		and a.modele=b.modele 
 order by a.annee, a.mois,a.marque, a.modele, a.segment;  
 
create table petrole2.modelcommun as select  distinct mois, annee, marque, 
		modele, segment  from diff_energie 
order by  annee,mois, marque, 
		modele, segment;

/*Instruments utilisant cost shifter pour instrumenter part intrasegment*/
 create table pour_instrument_intraseg as
		select distinct a.*,  
/*moyenne des costs shifters des autres modeles du segment*/
		sum(b.cs_caoutch_tb)/sum(b.vol_modenerg) as tots_cs_caoutch
		,sum(b.cs_lcaoutch_tb)/sum(b.vol_modenerg) as tots_cs_lcaoutch
		,sum(b.cs_fer_tb)/sum(b.vol_modenerg) as tots_cs_fer
		,sum(b.cs_lfer_tb)/sum(b.vol_modenerg) as tots_cs_lfer
   		from model a, temp b 
		where a.annee=b.annee and a.mois=b.mois 
		and a.segment=b.segment  
		/*sauf le modele, au sens large (essence ou diesel) considr */
		and (a.modele ne b.modele  )    
		group by a.annee, a.mois,a.marque, a.modele,
		a.segment, a.energie 		 
		order by a.annee, a.mois,a.marque, a.modele, a.segment, a.energie  ;
 create table pour_instrument_intraseg2 as
		select distinct a.*,  
		sum(b.cs_caoutch_tb)/sum(b.vol_modenerg) as totmod_cs_caoutch
		,sum(b.cs_lcaoutch_tb)/sum(b.vol_modenerg) as totmod_cs_lcaoutch
		,sum(b.cs_fer_tb)/sum(b.vol_modenerg) as totmod_cs_fer
		,sum(b.cs_lfer_tb)/sum(b.vol_modenerg) as totmod_cs_lfer
   		from model a, temp b 
		where a.annee=b.annee and a.mois=b.mois 
		and a.segment=b.segment 
		/*pour le modele, au sens large (essence ou diesel considr */
		and a.modele=b.modele  
		group by a.annee, a.mois,a.marque, a.modele,
		a.segment, a.energie 		 
		order by a.annee, a.mois,a.marque, a.modele, a.segment, a.energie  ;

 create table diff_intraseg as
		select distinct a.annee, a.mois,a.marque, a.modele, a.segment, a.energie ,  
		tots_cs_caoutch- totmod_cs_caoutch as difseg_cs_caoutch,
	    tots_cs_lcaoutch-totmod_cs_lcaoutch as difseg_cs_lcaoutch,
		tots_cs_fer-totmod_cs_fer as difseg_cs_fer,
		tots_cs_lfer-totmod_cs_lfer as difseg_cs_lfer
   		from pour_instrument_intraseg a, pour_instrument_intraseg2 b 
		where a.annee=b.annee and a.mois=b.mois 
		and a.segment=b.segment and a.marque=b.marque and b.modele=a.modele and b.energie=a.energie  
		group by a.annee, a.mois,a.marque, a.modele,
		a.segment, a.energie 		 
		order by a.annee, a.mois,a.marque, a.modele, a.segment, a.energie  ;
/*instruments  la BLP , 
	calcul des caractristiques moyennes des vhicules par marque et segment*/
		/*meme marque, meme segment*/
  create table pour_instrument1 as
		select distinct a.*,  
		/*sum(1) as totms,*/
		/*moyenne*/
        sum(b.prixkilomlag3mb)/sum(b.vol_modenerg) as totms_prixkilom, 
        sum(b.nbporte3b)/sum(b.vol_modenerg)  as totms_nbporte3 , 
        sum(b.nbporte5b)/sum(b.vol_modenerg)  as totms_nbporte5 ,  
        sum(b.gasole)/sum(b.vol_modenerg) as totms_gasole /*virgule enleve ici*/		
		%do i=1 %to 5 ;, mean(b.claspuis&i.b) as  totms_claspuis&i  %end;
        ,/*virgule ajoute ici*/sum(b.puis_kwb)/sum(b.vol_modenerg)  as  totms_puis_kw 
		%do i=0 %to 6 ;,  sum(b.clasco&i.b)/sum(b.vol_modenerg)   as  totms_clasco&i  %end;  
		,sum(b.cs_caoutch_tb)/sum(b.vol_modenerg) as totms_cs_caoutch
		,sum(b.cs_lcaoutch_tb)/sum(b.vol_modenerg) as totms_cs_lcaoutch
		,sum(b.cs_fer_tb)/sum(b.vol_modenerg) as totms_cs_fer
		,sum(b.cs_lfer_tb)/sum(b.vol_modenerg) as totms_cs_lfer
		/*somme*/
		,sum(b.prixkilomlag3mb) as totms_prixkilom_s, 
        sum(b.nbporte3b) as totms_nbporte3_s , 
        sum(b.nbporte5b) as totms_nbporte5_s ,  
        sum(b.gasole) as totms_gasole_s /*virgule enleve ici*/	
		%do i=1 %to 5 ;, sum(b.claspuis&i.b) as  totms_claspuis_s&i  %end;
		,/*virgule ajoute ici*/ 
		sum(b.puis_kwb) as  totms_puis_kw_s 
		%do i=0 %to 6 ;,  sum(b.clasco&i.b)  as  totms_clasco_s&i  %end;  
   		from model a, temp b 
		where a.annee=b.annee and a.mois=b.mois 
		and a.segment=b.segment and a.marque=b.marque 
		/*tous sauf le modele considr */
		and ((a.modele ne b.modele) or (a.energie ne b.energie)  )    
		group by a.annee, a.mois,a.marque, a.modele,
		a.segment, a.energie 		 
		order by a.annee, a.mois,a.marque, a.modele, a.segment, a.energie  ;
 
		/*meme marque, pas meme segment*/
  create table pour_instrument2 as
		select distinct a.*,  
		/*sum(1) as totmps,*/
		/*moyenne*/
        sum(b.prixkilomlag3mb)/sum(b.vol_modenerg)  as totmps_prixkilom, 
        sum(b.nbporte3b)/sum(b.vol_modenerg)  as totmps_nbporte3, 
        sum(b.nbporte5b)/sum(b.vol_modenerg)  as totmps_nbporte5,  
        sum(b.gasole)/sum(b.vol_modenerg)  as totmps_gasole	/*virgule enleve ici*/
		%do i=1 %to 5 ;, sum(b.claspuis&i.b) as  totmps_claspuis&i  %end; 
		,/*virgule ajoute ici*/sum(b.puis_kwb)/sum(b.vol_modenerg)  as  totmps_puis_kw   
		%do i=0 %to 6 ;,  sum(b.clasco&i.b)/sum(b.vol_modenerg)   as  totmps_clasco&i  %end;  
		,sum(b.cs_caoutch_tb)/sum(b.vol_modenerg) as totmps_cs_caoutch
		,sum(b.cs_lcaoutch_tb)/sum(b.vol_modenerg) as totmps_cs_lcaoutch
		,sum(b.cs_fer_tb)/sum(b.vol_modenerg) as totmps_cs_fer
		,sum(b.cs_lfer_tb)/sum(b.vol_modenerg) as totmps_cs_lfer
		/*somme*/
		,sum(b.prixkilomlag3mb) as totmps_prixkilom_s, 
        sum(b.nbporte3b) as totmps_nbporte3_s, 
        sum(b.nbporte5b) as totmps_nbporte5_s,  
        sum(b.gasole) as totmps_gasole_s /*virgule enleve ici*/
		%do i=1 %to 5 ;, sum(b.claspuis&i.b) as  totmps_claspuis_s&i  %end;
		,/*virgule ajoute ici*/ 
		sum(b.puis_kwb) as  totmps_puis_kw_s 
		%do i=0 %to 6 ;,  sum(b.clasco&i.b)  as  totmps_clasco_s&i  %end;  
		from model a, temp b 
		where a.annee=b.annee and a.mois=b.mois 
		and a.segment ne b.segment and a.marque=b.marque 
		/*tous sauf le modele considr 
		and ((a.modele ne b.modele) or (a.energie ne b.energie) )   */ 
 			group by a.annee, a.mois,a.marque, a.modele, a.segment, a.energie  
		order by a.annee, a.mois,a.marque, a.modele, a.segment, a.energie   ; 



		/*pas meme marque, pas meme segment*/
  create table pour_instrument3 as 
		select distinct a.*,  
		/*sum(1) as totpmps,*/
		/*moyenne*/
        sum(b.prixkilomlag3mb)/sum(b.vol_modenerg)  as totpmps_prixkilom, 
        sum(b.nbporte3b)/sum(b.vol_modenerg)  as totpmps_nbporte3, 
        sum(b.nbporte5b)/sum(b.vol_modenerg)  as totpmps_nbporte5,  
        sum(b.gasole)/sum(b.vol_modenerg)  as totpmps_gasole /*virgule enleve ici*/	
		%do i=1 %to 5 ;, sum(b.claspuis&i.b) as  totpmps_claspuis&i  %end;
        ,/*virgule ajoute ici*/sum(b.puis_kwb)/sum(b.vol_modenerg)  as  totpmps_puis_kw 
		%do i=0 %to 6 ;,  sum(b.clasco&i.b)/sum(b.vol_modenerg)   as  totpmps_clasco&i  %end;  
		,sum(b.cs_caoutch_tb)/sum(b.vol_modenerg) as totpmps_cs_caoutch
		,sum(b.cs_lcaoutch_tb)/sum(b.vol_modenerg) as totpmps_cs_lcaoutch
		,sum(b.cs_fer_tb)/sum(b.vol_modenerg) as totpmps_cs_fer
		,sum(b.cs_lfer_tb)/sum(b.vol_modenerg) as totpmps_cs_lfer
		/*somme*/
		,sum(b.prixkilomlag3mb) as totpmps_prixkilom_s, 
        sum(b.nbporte3b) as totpmps_nbporte3_s, 
        sum(b.nbporte5b) as totpmps_nbporte5_s,  
        sum(b.gasole) as totpmps_gasole_s /*virgule enleve ici*/
		%do i=1 %to 5 ;, sum(b.claspuis&i.b) as  totpmps_claspuis_s&i  %end; 
		,/*virgule ajoute ici*/sum(b.puis_kwb) as  totpmps_puis_kw_s 
		%do i=0 %to 6 ;,  sum(b.clasco&i.b)  as  totpmps_clasco_s&i  %end;  
   		from model a, temp b 
		where a.annee=b.annee and a.mois=b.mois 
		and a.segment ne b.segment and a.marque ne b.marque 
		/*tous sauf le modele considr 
		and ((a.modele ne b.modele) or (a.energie ne b.energie)  ) */   
				group by a.annee, a.mois,a.marque, a.modele, a.segment, a.energie  
		order by a.annee, a.mois,a.marque, a.modele, a.segment, a.energie    ; 

		/*pas meme marque, meme segment*/
create table pour_instrument4 as
		select distinct a.*,  
		/*sum(1) as totpms,*/
		/*moyenne*/
        sum(b.prixkilomlag3mb)/sum(b.vol_modenerg)  as totpms_prixkilom,
        sum(b.nbporte3b)/sum(b.vol_modenerg)  as totpms_nbporte3, 
        sum(b.nbporte5b)/sum(b.vol_modenerg)  as totpms_nbporte5,  
        sum(b.gasole)/sum(b.vol_modenerg)  as totpms_gasole /*virgule enleve ici*/	 
		%do i=1 %to 5 ;, sum(b.claspuis&i.b) as  totpms_claspuis&i  %end; 
		,/*virgule ajoute ici*/sum(b.puis_kwb)/sum(b.vol_modenerg)  as  totpms_puis_kw 
		%do i=0 %to 6 ;,  sum(b.clasco&i.b)/sum(b.vol_modenerg)   as  totpms_clasco&i %end; 
		,sum(b.cs_caoutch_tb)/sum(b.vol_modenerg) as totpms_cs_caoutch
		,sum(b.cs_lcaoutch_tb)/sum(b.vol_modenerg) as totpms_cs_lcaoutch
		,sum(b.cs_fer_tb)/sum(b.vol_modenerg) as totpms_cs_fer
		,sum(b.cs_lfer_tb)/sum(b.vol_modenerg) as totpms_cs_lfer
		/*somme*/
		,sum(b.prixkilomlag3mb) as totpms_prixkilom_s,
        sum(b.nbporte3b) as totpms_nbporte3_s, 
        sum(b.nbporte5b) as totpms_nbporte5_s,  
        sum(b.gasole) as totpms_gasole_s /*virgule enleve ici*/
		%do i=1 %to 5 ;, sum(b.claspuis&i.b) as  totpms_claspuis_s&i  %end; 
		,/*virgule ajoute ici*/sum(b.puis_kwb) as  totpms_puis_kw_s
		%do i=0 %to 6 ;,  sum(b.clasco&i.b)  as  totpms_clasco_s&i %end;
   		from model a, temp b 
		where a.annee=b.annee and a.mois=b.mois 
		and a.segment= b.segment and a.marque ne b.marque 
		/*tous sauf le modele considr */
		and ((a.modele ne b.modele) or (a.energie ne b.energie)  )    
				group by a.annee, a.mois,a.marque, a.modele, a.segment, a.energie  
		order by a.annee, a.mois,a.marque, a.modele, a.segment, a.energie    ;



		/*meme marque, ensemble*/
  create table pour_instrument2b as
		select distinct a.*,  
		sum(1) as totm,
		/*moyenne*/
        sum(b.prixkilomlag3mb)/sum(b.vol_modenerg)  as totm_prixkilom, 
        sum(b.nbporte3b)/sum(b.vol_modenerg)  as totm_nbporte3, 
        sum(b.nbporte5b)/sum(b.vol_modenerg)  as totm_nbporte5,  
        sum(b.gasole)/sum(b.vol_modenerg)  as totm_gasole /*virgule enleve ici*/
		%do i=1 %to 5 ;, sum(b.claspuis&i.b) as  totmps_claspuis&i  %end; 
		,/*virgule ajoute ici*/sum(b.puis_kwb)/sum(b.vol_modenerg)  as  totm_puis_kw 
		%do i=0 %to 6 ;,  sum(b.clasco&i.b)/sum(b.vol_modenerg)   as  totm_clasco&i  %end;  
		/*somme*/
		,sum(b.prixkilomlag3mb) as totm_prixkilom_s, 
        sum(b.nbporte3b) as totm_nbporte3_s, 
        sum(b.nbporte5b) as totm_nbporte5_s,  
        sum(b.gasole) as totm_gasole_s /*virgule enleve ici*/
		%do i=1 %to 5 ;, sum(b.claspuis&i.b) as  totmps_claspuis_s&i  %end; 
		,/*virgule ajoute ici*/sum(b.puis_kwb) as  totm_puis_kw_s 
		%do i=0 %to 6 ;,  sum(b.clasco&i.b)  as  totm_clasco_s&i  %end;  
   		from model a, temp b 
		where a.annee=b.annee and a.mois=b.mois 
		 and a.marque=b.marque 
		/*tous sauf le modele considr */
		and ((a.modele ne b.modele) or (a.energie ne b.energie) or (a.segment ne b.segment))    
 			group by a.annee, a.mois,a.marque, a.modele,a.segment , a.energie  
		order by a.annee, a.mois,a.marque, a.modele,a.segment , a.energie   ; 

		/*pas meme marque, ensemble*/
  create table pour_instrument3b as 
		select distinct a.*,  
		sum(1) as totpm, 
		/*moyenne*/
	    sum(b.prixkilomlag3mb)/sum(b.vol_modenerg)  as totpm_prixkilom, 
        sum(b.nbporte3b)/sum(b.vol_modenerg)  as totpm_nbporte3, 
        sum(b.nbporte5b)/sum(b.vol_modenerg)  as totpm_nbporte5,  
        sum(b.gasole)/sum(b.vol_modenerg)  as totpm_gasole /*virgule enleve ici*/
		%do i=1 %to 5 ;, sum(b.claspuis&i.b) as  totpmps_claspuis&i  %end; 
		,/*virgule ajoute ici*/sum(b.puis_kwb)/sum(b.vol_modenerg)  as  totpm_puis_kw 
		%do i=0 %to 6 ;,  sum(b.clasco&i.b)/sum(b.vol_modenerg)   as  totpm_clasco&i  %end;  
		/*somme*/
	    ,sum(b.prixkilomlag3mb) as totpm_prixkilom_s, 
 		sum(b.nbporte3b) as totpm_nbporte3_s, 
        sum(b.nbporte5b) as totpm_nbporte5_s,  
        sum(b.gasole) as totpm_gasole_s /*virgule enleve ici*/
		%do i=1 %to 5 ;, sum(b.claspuis&i.b) as  totpmps_claspuis_s&i  %end; 
		,/*virgule ajoute ici*/sum(b.puis_kwb) as  totpm_puis_kw_s 
		%do i=0 %to 6 ;,  sum(b.clasco&i.b)  as  totpm_clasco_s&i  %end;  
		from model a, temp b 
		where a.annee=b.annee and a.mois=b.mois 
		  and a.marque ne b.marque 
		/*tous sauf le modele considr */
		and ((a.modele ne b.modele) or (a.energie ne b.energie) or (a.segment ne b.segment)  )    
				group by a.annee, a.mois,a.marque, a.modele, a.segment, a.energie  
		order by a.annee, a.mois,a.marque, a.modele, a.segment, a.energie    ; 
		 
		/*calcul du nombre de modele par an et par segment - voir Ackerberg et Rysman*/
create table pour_instrument5 as
		select distinct *,
        sum(1) as nb_model 
   		from model
		group by  annee,  mois,segment
		order by annee, mois,marque, modele, segment,energie   ;

create table pour_instrument5b as
 		select distinct *,
        sum(1) as nb_modeltot 
   		from model
		group by  annee,  mois 
		order by annee, mois,marque, modele, segment,energie   ;
create table pour_instrument6 as
		select *,
        sum( energie ne 'GAZOLE' ) as nb_modelsuper
   		from model  
		group by  annee,  mois,segment
		order by annee, mois,marque, modele, segment,energie   ;
		
create table pour_instrument6b as
		select distinct *,
        sum( energie ne 'GAZOLE' ) as nb_modelsupertot
   		from model  
		group by  annee,  mois 
		order by annee, mois,marque, modele, segment,energie   ;

create table pour_instrument7 as
		select distinct *,
        sum(energie='GAZOLE') as nb_modeldiesel 
   		from model   
		group by  annee,  mois,segment
		order by annee, mois,marque, modele, segment,energie   ;
		
create table pour_instrument7b as
		select distinct *,
        sum(energie='GAZOLE') as nb_modeldieseltot 
   		from model   
		group by  annee,  mois 
		order by annee, mois,marque, modele, segment,energie   ;
quit;
 
proc sort data=costshifters;
by annee mois marque modele segment energie;run; 

data  instrument;
merge model pour_instrument1  pour_instrument2  pour_instrument3 
pour_instrument2b  pour_instrument3b  
 pour_instrument4 pour_instrument5 pour_instrument6 pour_instrument7
 pour_instrument5b pour_instrument6b pour_instrument7b
 costshifters  diff_intraseg
;
by annee mois marque modele segment energie;run; 
 
  

%let listvariable= nbporte3 nbporte5 prixkilomlag3m puis_kw claspuis1 claspuis2 claspuis3 claspuis4 claspuis5 
clasco0 clasco1 clasco2 clasco3 clasco4 clasco5 clasco6;
%let listcostshif=  cs_caoutch  cs_fer cs_lcaoutch cs_lfer ;  /*cs_2211 cs_241 cs_292 cs_293 cs_l2211
cs_l241 cs_l292 cs_l293*/
%let nbvariable=%sysfunc(countw(&listvariable.));   
%let nbcostshif=%sysfunc(countw(&listcostshif.));   
 
data diff_energie2;merge temp (in=a
keep= annee mois marque modele segment energie nbporte3b nbporte5b prixkilomlag3mb
puis_kwb 
 claspuis1b claspuis2b claspuis3b claspuis4b claspuis5b 
clasco0b clasco1b clasco2b clasco3b clasco4b clasco5b clasco6b) costshifters(in=c) petrole2.modelcommun(in=b);
/*uniquement pour les modles achet ce mois-ci seulement en version essence ou diesel*/
/*quand le modle n'est dispo que dans une version, on met ses caractristiques*/
if (a and c) and not b;
by annee mois marque modele segment ;
rename %do j=1 %to &nbvariable.; 
%scan(&listvariable.,&j.)b=diff_%scan(&listvariable.,&j.)b
%end; 
%do j=1 %to &nbcostshif.; 
%scan(&listcostshif.,&j.)=diff_%scan(&listcostshif.,&j.)b
%end; 
;
run;   


data  instrument_comm;
merge instrument(in=a) diff_energie(in=b) diff_costshift(in=c);
by annee mois marque modele segment ; if a and b and c;
 	%do j=1 %to &nbvariable.; 
			if energie ="ESSENCE"  then diff_%scan(&listvariable.,&j.)b=-diff_%scan(&listvariable.,&j.);
			else diff_%scan(&listvariable.,&j.)b=diff_%scan(&listvariable.,&j.);
			%end;  
 			%do j=1 %to &nbcostshif.; 	if energie ="ESSENCE"  then diff_%scan(&listcostshif.,&j.)b=-diff_%scan(&listcostshif.,&j.);
			else diff_%scan(&listcostshif.,&j.)b=diff_%scan(&listcostshif.,&j.);
			%end;  
drop 	  %do j=1 %to &nbvariable.;  diff_%scan(&listvariable.,&j.) %end; %do j=1 %to &nbcostshif.; diff_%scan(&listcostshif.,&j.) %end; ;
run; 

data instrument_noncomm;merge instrument(in=a) diff_energie2(in=b) ;
by annee mois marque modele segment energie; 
if a and b ;
run; 
data petrole2.instrumenttvared (compress=YES);merge instrument_comm(in=a) instrument_noncomm; 
by annee mois marque modele segment energie; 
/*mai 2014 : filtre supprim pour un test / on supprime les modeles avec un seul modele de la marque par segment */
/*if totms_prixkilom ne .; */
modelcomm=a;
run;
%mend;
%pourinstrument; 
 


PROC DATASETS LIB=work KILL NOLIST;run;
