/*For specification ignoring buyer heterogeneity */

options fullstimer;
options BUFSIZE=32k BUFNO=2k;
options compress=yes ;

/*observation : month, year, marque, modele, segment, energy*/
/*Three nests : segment/modele/energie*/
/*Input data : petrole.total et petrole2.instrumenttvared*/
/*Output data : petrole2.tablesparts1demotvared petrole.parts1demotvared */

libname petrole "V:\DG75-GD3E\DMSE\Petrole\tables travail";
 
 %macro nested_logit1demo; 
proc sql;
/* 1 modle = marque*modele*energie2*segment  */
	create table model as
		select distinct mois, annee, marque, modele, segment, energie  
		from petrole.total  ; 

   create table ventesparmod_energ as
		select distinct annee, mois, 
		segment,marque, modele, energie , 
		sum(volume*prix)/sum(volume) as prix_m,
		sum(volume*prixkilomlag3m)/sum(volume) as prixkilomlag3m_m,
		sum(volume*conso)/sum(volume) as conso_m,
		sum(volume*nb_portes=3)/sum(volume) as nbportes3,
		sum(volume*nb_portes=5)/sum(volume) as nbportes5,
		sum(volume*puis_kw)/sum(volume) as puis_kw 
		%do i=1 %to 5 ;, 
		sum(volume*claspuis&i.)/sum(volume) as  claspuis&i.  
		%end; 
		%do i=0 %to 6 ;, 
		sum(volume*clasco&i.)/sum(volume) as  clasco&i.  
		%end;  
		,sum(volume) as totmod_energ  
		from petrole.total 
		group by annee, mois,  
		 segment,marque, modele, energie 
        order by/* demo,*/ annee, mois, segment ,marque, modele   ;
 
  create table ventesparmodele as
		select distinct annee, mois, segment,marque, modele  ,
		sum(totmod_energ) as tot_mod  ,
		sum((energie='GAZOLE')*totmod_energ) /sum(totmod_energ) as partdiesel_mod,
		sum(conso_m*totmod_energ) /sum(totmod_energ) as conso_mod,
		sum(conso_m*totmod_energ*(energie='GAZOLE'))/sum(totmod_energ*(energie='GAZOLE')) 
				as consodies_mod
		from ventesparmod_energ 
		group by annee, mois,   segment,marque, modele 
		order by  annee, mois,  segment,marque, modele ; 
 
  
  create table ventesparsegment as
		select distinct annee, mois, segment  ,
		sum(tot_mod) as tot_seg  ,
		sum(partdiesel_mod*tot_mod) /sum(tot_mod) as partdiesel_seg,
		sum(conso_mod*tot_mod) /sum(tot_mod) as conso_seg,
		sum(consodies_mod*partdiesel_mod*tot_mod)/sum(partdiesel_mod*tot_mod ) 
				as consodies_seg
		from ventesparmodele 
		group by annee, mois , segment 
		order by  annee, mois, segment;  
 

data parts_glob;
	merge ventesparmod_energ ventesparmodele;
	by annee  mois segment marque modele;
run;

data parts_glob;
	merge parts_glob  ventesparsegment ;
	by   annee  mois segment ;
run;

/**ATTENTION: on ne peut pas sommer directement pour avoir les ventes totales par mois***/
/*dans chaque segment autant de lignes que de modele avec le meme tot_seg */
proc sql;
create table temp as select distinct 
annee,mois,  
tot_seg,conso_seg,partdiesel_seg,consodies_seg,consodies_mod,  
/*moyenne pondre par part du modele en diesel sur ensemble des diesel de la conso moyenne par modele / par version (ie conso moyenne des diesels)*/
		sum(conso_m*totmod_energ*(energie='GAZOLE'))/sum(totmod_energ *(energie='GAZOLE') ) as consodies_tot
from parts_glob
group by annee, mois 
order by annee, mois  ;


create table petrole.partsglob_tot1demotvared 
as select distinct 
annee,mois, consodies_tot,consodies_seg,consodies_mod,
        sum(tot_seg) as tot_tot,
        sum(tot_seg*conso_seg)/sum(tot_seg) as conso_moytot,
		sum(partdiesel_seg*tot_seg) /sum(tot_seg) as partdiesel_tot
        from temp 
group by annee, mois 
order by  annee, mois  
;  

data parts_glob;merge parts_glob petrole.partsglob_tot1demotvared  ;by  annee  mois  ;run;
proc sort data=parts_glob;
	by annee mois  marque modele segment energie    ;

data parts_glob;
	merge parts_glob(in=a) petrole2.instrumenttvared(in=b);
	by annee mois marque modele segment energie     ;
	if a and b;
run;
%mend; 

 %nested_logit1demo;
 

data petrole.tablesparts1demotvared (compress=yes);	
set parts_glob ;
/*TVA dductible pour les entreprises*/
if (substr(left(demo),1,1)='1') and (energie='GAZOLE') then prixkilomlag3m_m=prixkilomlag3m_m*1.0392/1.196;
  

	log_parts= log(totmod_energ); 
	log_partsmod = log(totmod_energ / tot_mod);
	log_partsseg = log(tot_mod / tot_seg);
	log_partsseg2=log(totmod_energ/ tot_seg);
	log_prix = log(prix_m);  
	log_prixkilomlag3m = log(prixkilomlag3m_m);  
run; 
 

PROC DATASETS LIB=work KILL NOLIST;run;
 /*pour tester modele agrege sur l'ensemble des catgories demo*/

%macro tablesgmm1demo;

/*on cre des indicatrices avec les principales variables*/
data petrole.parts1demotvared;set petrole.tablesparts1demotvared (drop = demo where=(annee<2007 or mois<11)); 
format  marque0-marque15 segment0-segment4 m1-m12 an1-an5 3.;

datem=(annee-2003)*12+mois;
array date[58] date1-date58;
do i=1 to 58;
date[i]=(datem=i);
end;

gasole=(energie='GAZOLE');
sqr_prixkilomlag3m_m=(prixkilomlag3m_m)**(0.5);
marque1=(marque='AUDI');
marque2=(marque='B.M.W.');
marque3=(marque='CITROEN');
marque4=(marque='FIAT');
marque5=(marque='FORD');
marque6=(marque='HYUNDAI');
marque7=(marque='MERCEDES');
marque8=(marque='NISSAN');
marque9=(marque='OPEL');
marque10=(marque='PEUGEOT');
marque11=(marque='SEAT');
marque12=(marque='SUZUKI');
marque13=(marque='TOYOTA');
marque14=(marque='VOLKSWAGEN');
marque15=(marque='RENAULT');
marque0=1-marque1-marque2-marque3-marque4-marque5-marque6-marque7-marque8-marque9-
marque10-marque11-marque12-marque13-marque14-marque15;
segment0=(segment = "TT-TERR");
segment1=(segment = "UTILIT");
segment2=(segment = "MONOSP"); 
segment3=(segment = "CITADINE"); 
segment4=(segment = "COMPACTE"); 

array an[5] an1-an5;
do i=1 to 5;
 an[i]=(annee=2002+i);
end; 

array m[12] m1-m12;
do i=1 to 12;
 m[i]=(mois=i);
end; 
q1=(mois in ('1','2','3'));
q2=(mois in ('4','5','6'));
q3=(mois in ('7','8','9'));
q4=(mois in ('10','11','12'));
 
run;  
 %mend;

 %tablesgmm1demo;
 



