options fullstimer;
options BUFSIZE=32k BUFNO=2k;
options compress=yes ;
libname tau "V:\DG75-GD3E\DMSE\Petrole\Sources donnees\tables demo";
 libname petrole "V:\DG75-GD3E\DMSE\Petrole\tables travail";
libname petrole2 "u:\Petrole\tables travail";

 /********* Table 1 : descriptive statsics of cars******************/
 /*Table : Nombre de produits et volume sur la priode*/
/* dispersion of car features, demo in CCFA data*/
 
proc format;
 value nbportes
2,4,6,9="Others"
3="3"
5="5"
; 
proc contents data=petrole.total;run;

/************************ Table 1: descriptive statistics of cars***************************/
/*nombres de modeles et volume des ventes sur l'ensemble de la priode par caractristiques*/
/* on utilise les variables servant pour la dfinition des modles*/
/* marque*modele*energie2*segment*ClassCO2*ClassPuis*/
 
proc sql;
create table modele as select distinct sum(volume) as vol, 
marque, modele, segment, energie ,classCo2 ,classpuis  from  petrole.total
group by marque, modele,  segment, energie ,classCo2 ,classpuis 
order by marque, modele,  segment,  energie ,classCo2 ,classpuis ; 
 
proc summary data= modele;var vol; 
class  segment energie classCo2 classpuis;
output out=volume sum=volume n=nombre; 
run;  
 
data sortie;
retain variable valeur nombre volume;
set volume;
where _type_ in (0,1,2,4,8);
valeur='           ';
if  _type_=1 then do;Variable="Horsepower";valeur= classpuis;end;
if  _type_=2 then do;Variable="C02 Class";valeur=classCo2;end;
if  _type_=4 then do;Variable="Energy";valeur=energie ; end;
if  _type_=8 then do;Variable="Segment";valeur=segment ; end; 
if  _type_=0 then do;Variable="All";end; 
percent_nb = nombre /2160*100;
percent_vol = volume/7405367*100 ;
keep  variable valeur nombre percent_nb volume percent_vol;
run;
title 'nombre de modles et volumes vendus';
proc print data=sortie;run;  

/*23/12/2016
                                                                     percent_    percent_
               

                           1     All                        2166     9051110     100.278     122.224
                           2     Horsepower    1             299     2869369      13.843      38.747
                           3     Horsepower    2             763     5061239      35.324      68.346
                           4     Horsepower    3             587      871266      27.176      11.765
                           5     Horsepower    4             292      197756      13.519       2.670
                           6     Horsepower    5             225       51480      10.417       0.695
                           7     C02 Class     A               3        1373       0.139       0.019
                           8     C02 Class     B              78     1505202       3.611      20.326
                           9     C02 Class     C             186     2314618       8.611      31.256
                          10     C02 Class     D             311     2826581      14.398      38.169
                          11     C02 Class     E             630     1759070      29.167      23.754
                          12     C02 Class     F             569      495813      26.343       6.695
                          13     C02 Class     G             389      148453      18.009       2.005
                          14     Energy        ESSENCE      1250     2693193      57.870      36.368
                          15     Energy        GAZOLE        916     6357917      42.407      85.856
                          16     Segment       BERLINE       715     2488633      33.102      33.606
                          17     Segment       CITADINE       73      574469       3.380       7.757
                          18     Segment       COMPACTE      300     2918897      13.889      39.416
                          19     Segment       MONOSP        286     2008695      13.241      27.125
                          20     Segment       SPORT         436      290040      20.185       3.917
                          21     Segment       TT-TERR       218      436517      10.093       5.895
                          22     Segment       UTILIT        138      333859       6.389       4.508


*/

/*idem en enlevant ventes automobiles*/
proc sql;
create table modele as select distinct sum(volume) as vol, 
marque, modele, segment, energie ,classCo2 ,classpuis  from  
petrole.total(where=(demo not in ('1_0_B','1_1_B','1_2_B','1_3_B'))) 
group by marque, modele,  segment, energie ,classCo2 ,classpuis 
order by marque, modele,  segment,  energie ,classCo2 ,classpuis ; 
 
proc summary data= modele;var vol; 
class  segment energie classCo2 classpuis;
output out=volume sum=volume n=nombre; 
run;  
 
data sortie;
retain variable valeur nombre volume;
set volume;
where _type_ in (0,1,2,4,8);
valeur='           ';
if  _type_=1 then do;Variable="Horsepower";valeur= classpuis;end;
if  _type_=2 then do;Variable="C02 Class";valeur=classCo2;end;
if  _type_=4 then do;Variable="Energy";valeur=energie ; end;
if  _type_=8 then do;Variable="Segment";valeur=segment ; end; 
if  _type_=0 then do;Variable="All";end; 
percent_nb = nombre /2160*100;
percent_vol = volume/7405367*100 ;
keep  variable valeur nombre percent_nb volume percent_vol;
run;
title 'nombre de modles et volumes vendus';
proc print data=sortie;run;  

/*04/01/2017

                                                                  percent_    percent_
            Obs    variable      valeur      nombre     volume       nb          vol

              1    All                        2148     7828903     99.4444     105.719
              2    Horsepower    1             299     2507219     13.8426      33.857
              3    Horsepower    2             754     4422395     34.9074      59.719
              4    Horsepower    3             585      703645     27.0833       9.502
              5    Horsepower    4             287      156139     13.2870       2.108
              6    Horsepower    5             223       39505     10.3241       0.533
              7    C02 Class     A               3        1136      0.1389       0.015
              8    C02 Class     B              78     1320097      3.6111      17.826
              9    C02 Class     C             185     2019405      8.5648      27.269
             10    C02 Class     D             309     2441944     14.3056      32.975
             11    C02 Class     E             625     1522154     28.9352      20.555
             12    C02 Class     F             563      408740     26.0648       5.520
             13    C02 Class     G             385      115427     17.8241       1.559
             14    Energy        ESSENCE      1238     2376527     57.3148      32.092
             15    Energy        GAZOLE        910     5452376     42.1296      73.627
             16    Segment       BERLINE       708     2160269     32.7778      29.172
             17    Segment       CITADINE       73      486567      3.3796       6.570
             18    Segment       COMPACTE      299     2544687     13.8426      34.363
             19    Segment       MONOSP        285     1758438     13.1944      23.745
             20    Segment       SPORT         428      235408     19.8148       3.179
             21    Segment       TT-TERR       218      340209     10.0926       4.594
             22    Segment       UTILIT        137      303325      6.3426       4.096

*/

/*********** Tables 2 and 3 : cost pf driving 100 km and share of diesel cars by demo*****************/

data total;
set petrole.total(where=(demo not in ('1_0_B','1_1_B','1_2_B','1_3_B'))) ;
diesel=(energie='GAZOLE'); 
run; 

proc sort data=total;
by demo;
run;

proc summary data=total;
var diesel prixkilomdef ; weight volume; output out=stats_diesel_prixkilom_demo mean=;
class demo;
run;

proc print data=stats_diesel_prixkilom_demo;run; 

PROC EXPORT DATA= stats_diesel_prixkilom_demo
            OUTFILE= "V:\DG75-GD3E\DMSE\Petrole\sorties\stats_diesel_prixkilom_demo2.xls" 
            DBMS=csv REPLACE;
RUN;

/*04/01/2017

                  Obs     demo      _TYPE_     _FREQ_     diesel    prixkilomdef

                    1                  0      6062395    0.69644       6.52827
                    2    0_0_0_0       1        39770    0.43873       7.37631
                    3    0_0_1_0       1       184602    0.57775       6.86145
                    4    0_0_2_0       1       485317    0.49390       7.19763
                    5    0_1_0_0       1        11002    0.59075       6.88542
                    6    0_1_1_0       1        44906    0.71404       6.49661
                    7    0_1_2_0       1        81753    0.65085       6.68140
                    8    0_2_0_1       1       144490    0.53991       6.87868
                    9    0_2_0_2       1        81520    0.57899       6.83428
                   10    0_2_1_1       1       380934    0.67326       6.43300
                   11    0_2_1_2       1       191156    0.68263       6.58929
                   12    0_2_2_1       1       676984    0.55003       6.82002
                   13    0_2_2_2       1       644710    0.58512       6.85772
                   14    0_3_0_1       1       135522    0.65503       6.58358
                   15    0_3_0_2       1       115871    0.65130       6.62995
                   16    0_3_1_1       1       245528    0.80393       6.16470
                   17    0_3_1_2       1       329973    0.77405       6.30742
                   18    0_3_2_1       1       449918    0.68260       6.49561
                   19    0_3_2_2       1       563996    0.68628       6.55598
                   20    1_0_A         1        87712    0.73328       7.03804
                   21    1_0_C         1       131192    0.81514       6.71244
                   22    1_0_E         1       121395    0.88571       6.07004
                   23    1_1_A         1         6734    0.84415       6.60185
                   24    1_1_C         1        10817    0.87966       6.32470
                   25    1_1_E         1         2955    0.95910       5.89471
                   26    1_2_A         1       201335    0.83594       6.38080
                   27    1_2_C         1       279665    0.87632       6.15184
                   28    1_2_E         1       193099    0.74217       6.16248
                   29    1_3_A         1        97518    0.90754       6.40421
                   30    1_3_C         1       113240    0.92615       6.21643
                   31    1_3_E         1         8781    0.76546       5.94814


*/

 /********* Figure 3 : calcul conso moyenne et parts diesel par commune (pour envoi  Helene pour cartes)*****************/

/* arrond correspond  la conversion du fichier correspondance fournit par Helene, sans les libelles*/
data tau.arrondissement;set arrond;
format codgeo $8.;
codgeotemp=put(left(insee_com),$8.);
test= length(codgeotemp);
if test <5 then codgeo="0"||codgeotemp;else codgeo=codgeotemp;
run;
 
data total;
set petrole.neuf03demo 
petrole.neuf04demo 
petrole.neuf05demo 
petrole.neuf06demo 
petrole.neuf07demo ;
/*exclusion des valeurs aberrantes (155 obs avec Co2=999) , 6 lignes avec prix 999999999 et modeles aberrants*/
	where energie in ('ESSENCE','GAZOLE') and CO2 <999 
		and carrosserie_cg not in ('TC',' NON SPEC',' DERIV VP' )
and marque not in ('DIV FRANCE',' DIV G.B.') and PRIX_VEHIC <99999999 ;

prof=(c_s_p < "A1");
diesel=(energie="GAZOLE");
if energie="ESSENCE" then conso=co2*0.043;  
if energie="GAZOLE" then conso=co2*0.038;
zonen=zone*1;
keep codgeo volume c_s_p co2 energie conso diesel prof zonen;
run;   

proc sort data=total;by codgeo;
proc sort data=tau.Arrondissement;by codgeo;
data test ;set tau.Arrondissement(where=(insee_com ne .));
data final; merge total tau.Arrondissement(where=(insee_com ne .));
by codgeo;
run;

proc summary data=total; output out=parcommunes  mean=; 
weight volume ;
var conso diesel zonen;class codgeo;
run;
data parcommunes;set parcommunes(where=(_type_=1)keep =codgeo conso diesel zonen _type_);
rename conso=consomoy diesel=partdiesel;drop _type_;
run;

PROC EXPORT DATA= WORK.parcommunes
            OUTFILE= "V:\DG75-GD3E\DMSE\Petrole\sorties\parcommunes" 
            DBMS=csv REPLACE;
RUN;

proc summary data=final; output out=pararrond  mean=; 
weight volume ;
var conso diesel ;class code_arr;
run;
data pararrond;set pararrond(where=(_type_=1)keep =code_arr conso diesel  _type_);
rename conso=consomoy diesel=partdiesel;drop _type_;
run;

PROC EXPORT DATA= WORK.pararrond
            OUTFILE= "V:\DG75-GD3E\DMSE\Petrole\sorties\pararrond" 
            DBMS=csv REPLACE;
RUN;

proc summary data=total; output out=parcommunesprof  mean=; 
weight volume ;
var conso diesel;class codgeo prof;
run;
data parcommunesprof;set parcommunesprof(where=(_type_=3) keep =codgeo conso prof diesel _type_);
rename conso=consomoypr diesel=partdieselpr;drop _type_;
run;

PROC EXPORT DATA= WORK.parcommunesprof
            OUTFILE= "V:\DG75-GD3E\DMSE\Petrole\sorties\parcommunesprof" 
            DBMS=csv REPLACE;
RUN;
 
proc sql;
create table sum as select unique sum(volume) as n, demo from petrole.total group by demo;  


PROC EXPORT DATA= WORK.sum
            OUTFILE= "V:\DG75-GD3E\DMSE\Petrole\sorties\nombrebydemo" 
            DBMS=csv REPLACE;
RUN;
 
/**********Table 8 : par catgorie dmo non pondr*********************/
proc freq data=petrole2.tablespartstvared;
table demo; run ;
 /* 23/12/2016           

                                                                        Frquence    Pctage
                                demo       Frquence     Pourcentage     cumule      cumul
                                
                                0_0_0_0        7050          1.62           7050       1.62
                                0_0_1_0       14931          3.43          21981       5.04
                                0_0_2_0       20859          4.79          42840       9.83
                                0_1_0_0        3668          0.84          46508      10.67
                                0_1_1_0        9235          2.12          55743      12.79
                                0_1_2_0       12041          2.76          67784      15.56
                                0_2_0_1       11910          2.73          79694      18.29
                                0_2_0_2        9634          2.21          89328      20.50
                                0_2_1_1       17488          4.01         106816      24.51
                                0_2_1_2       15086          3.46         121902      27.98
                                0_2_2_1       21185          4.86         143087      32.84
                                0_2_2_2       21489          4.93         164576      37.77
                                0_3_0_1       11044          2.53         175620      40.30
                                0_3_0_2       10761          2.47         186381      42.77
                                0_3_1_1       14785          3.39         201166      46.17
                                0_3_1_2       16389          3.76         217555      49.93
                                0_3_2_1       18666          4.28         236221      54.21
                                0_3_2_2       20140          4.62         256361      58.83
                                1_0_A         13890          3.19         270251      62.02
                                1_0_B         17816          4.09         288067      66.11
                                1_0_C         14300          3.28         302367      69.39
                                1_0_E         12097          2.78         314464      72.17
                                1_1_A          3278          0.75         317742      72.92
                                1_1_B          5285          1.21         323027      74.13
                                1_1_C          4616          1.06         327643      75.19
                                1_1_E          1511          0.35         329154      75.54
                                1_2_A         16146          3.71         345300      79.24
                                1_2_B         21648          4.97         366948      84.21
                                1_2_C         16355          3.75         383303      87.96
                                1_2_E         13416          3.08         396719      91.04
                                1_3_A         11715          2.69         408434      93.73
                                1_3_B         11977          2.75         420411      96.48
                                1_3_C         11850          2.72         432261      99.20
                                1_3_E          3489          0.80         435750     100.00


 

*/
proc freq data=petrole2.tablespartstvared;weight  totmod_energ;
table demo; run ;/*


                                                                        Frquence    Pctage
                                demo       Frquence     Pourcentage     cumule      cumul
                                
                                0_0_0_0       40298          0.45          40298       0.45
                                0_0_1_0      186758          2.06         227056       2.51
                                0_0_2_0      486700          5.38         713756       7.89
                                0_1_0_0       11069          0.12         724825       8.01
                                0_1_1_0       45160          0.50         769985       8.51
                                0_1_2_0       81893          0.90         851878       9.41
                                0_2_0_1      150214          1.66        1002092      11.07
                                0_2_0_2       82692          0.91        1084784      11.99
                                0_2_1_1      389903          4.31        1474687      16.29
                                0_2_1_2      192957          2.13        1667644      18.42
                                0_2_2_1      679981          7.51        2347625      25.94
                                0_2_2_2      646949          7.15        2994574      33.09
                                0_3_0_1      136187          1.50        3130761      34.59
                                0_3_0_2      116348          1.29        3247109      35.88
                                0_3_1_1      246876          2.73        3493985      38.60
                                0_3_1_2      331066          3.66        3825051      42.26
                                0_3_2_1      450728          4.98        4275779      47.24
                                0_3_2_2      564686          6.24        4840465      53.48
                                1_0_A        203606          2.25        5044071      55.73
                                1_0_B        189624          2.10        5233695      57.82
                                1_0_C        172532          1.91        5406227      59.73
                                1_0_E        313880          3.47        5720107      63.20
                                1_1_A          7674          0.08        5727781      63.28
                                1_1_B         15099          0.17        5742880      63.45
                                1_1_C         25129          0.28        5768009      63.73
                                1_1_E          4083          0.05        5772092      63.77
                                1_2_A        307871          3.40        6079963      67.17
                                1_2_B        884758          9.78        6964721      76.95
                                1_2_C        374754          4.14        7339475      81.09
                                1_2_E       1261364         13.94        8600839      95.03
                                1_3_A        113947          1.26        8714786      96.28
                                1_3_B        132726          1.47        8847512      97.75
                                1_3_C        137182          1.52        8984694      99.27
                                1_3_E         66416          0.73        9051110     100.00
*/

/************** Table 9: descriptive statics of key variables********************/
proc sort data=petrole.total(where=(demo not in ('1_0_B','1_1_B','1_2_B','1_3_B'))) out=temp;
by energie ; 
run;

proc means data = temp  mean cv q1 median q3;
	var prix_vehic prixkilomdef puis_kw conso CO2 ;
	weight volume ;
	by energie ;
run ;
proc freq data=temp   ;
tables energie;	weight volume ;run ;

/*04/01/2017

---------------------------------------- ENERGIE=ESSENCE -----------------------------------------

                                       The MEANS Procedure

                                       Coeff of           Lower                           Upper
   Variable                Mean       Variation        Quartile          Median        Quartile
   
   PRIX_VEHIC          16605.82      69.3743210        11738.00        13975.00        18800.00
   prixkilomdef       8.4140173      22.6822254       7.2958960       8.1143828       9.1286712
   PUIS_KW           70.3954569      48.8213594      54.0000000      60.0000000      80.0000000
   conso              6.8496442      21.6605437       5.9770000       6.5360000       7.3960000
   CO2              159.2940518      21.6605437     139.0000000     152.0000000     172.0000000
   


----------------------------------------- ENERGIE=GAZOLE -----------------------------------------

                                       Coeff of           Lower                           Upper
   Variable                Mean       Variation        Quartile          Median        Quartile
   
   PRIX_VEHIC          22967.52      40.9640020        16783.00        21875.00        26236.00
   prixkilomdef       5.7063357      27.1210314       4.8399298       5.4195614       6.3081826
   PUIS_KW           78.0857531      34.6285180      63.0000000      78.0000000      88.0000000
   conso              5.5859628      24.4789543       4.7120000       5.3580000       5.9660000
   CO2              146.9990213      24.4789543     124.0000000     141.0000000     157.0000000
   
 				     The FREQ Procedure
 


                                                       Cumulative    Cumulative
                   ENERGIE    Frequency     Percent     Frequency      Percent
                   
                   ESSENCE     2376527       30.36       2376527        30.36
                   GAZOLE      5452376       69.64       7828903       100.00


*/

/************** Stats modles communs**********************/
proc sort data=petrole2.tablespartstvared(where=(demo not in ('1_0_B','1_1_B','1_2_B','1_3_B')))  out=temp;
by modelcomm ; 
run; 

proc means data=temp N mean std min max sum ;
var nb_model ;
by modelcomm ; 
run; 
/*04/01/2017

------------------------------------------ modelcomm=0 -------------------------------------------

                                       The MEANS Procedure

                                   Analysis Variable : nb_model

           N            Mean         Std Dev         Minimum         Maximum             Sum
      
       76269      88.5692352      40.9172173      10.0000000     179.0000000      6755087.00
      


------------------------------------------ modelcomm=1 -------------------------------------------

                                   Analysis Variable : nb_model

           N            Mean         Std Dev         Minimum         Maximum             Sum
      
      302755      90.5974831      44.4374490      10.0000000     179.0000000     27428841.00
      


*/
/*Les modles communs reprsentent donc 80% des modles (= 302755/(302755+76269) ou =27428841/(27428841+6755087))
*/ 

proc sort data=petrole2.tablespartstvared(where=(demo not in ('1_0_B','1_1_B','1_2_B','1_3_B'))) out=temp;
by annee mois demo marque modele segment;
run ; 

proc sort data=petrole.total(where=(demo not in ('1_0_B','1_1_B','1_2_B','1_3_B'))) out=temp2;
by annee mois demo marque modele segment;
run ; 

data test;
merge temp (keep=annee mois demo marque modele segment modelcomm) temp2;
by annee mois demo marque modele segment ;
run ; 

proc sort data=test ;
by modelcomm;
run ; 
proc means data=test N mean std min max sum ;
var volume ;
by modelcomm ; 
run; 

/*4/01/2017
------------------------------------------ modelcomm=0 -------------------------------------------

                                       The MEANS Procedure

                                   Analysis Variable : VOLUME

           N            Mean         Std Dev         Minimum         Maximum             Sum
     
      387799       1.2062589       4.6034965       1.0000000         1006.00       467786.00
     


------------------------------------------ modelcomm=1 -------------------------------------------

                                   Analysis Variable : VOLUME

           N            Mean         Std Dev         Minimum         Maximum             Sum
     
     5674596       1.2972055       6.1461693               0         1974.00      7361117.00
     


*/
/*Les modles communs reprsentent donc 94% des volumes vendus (=5674596/(387799+5674596)
ou =7800525/(7800525+540988))
*/
