options fullstimer;
options BUFSIZE=32k BUFNO=2k;
options compress=yes ; 


libname petrole "\\ulysse\users\givord\@Encours\petrole\tables travail";
libname sorttemp "\\ulysse\users\givord\@Encours\petrole\sortiestemporaires";
/*Macro GMM estimation */ 
/*Input Table: &data*/
/*Output data (for boostrap) : sorttemp.&tab_param*/
 


%macro regression_nestedlogit_en(data=,list_inst=,list_endog=,list_exog=,tab_param=,nomvariante=,nest=);
/*Nb Instruments*/
%let nb_inst=%sysfunc(countw(&list_inst.)); 
%let nb_endog=%sysfunc(countw(&list_endog.)); 
%let nb_exog=%sysfunc(countw(&list_exog.));  
  
/*GMM estimation, unconstrained model*/ 
proc model data= &data plots=none;
by  replicate  demo; 
 
/*For bootstrap*/
endogenous &list_endog.;
instruments &list_inst. &list_exog. ;
label
%do j=1 %to &nb_endog.;
b_&j. = "%scan(&list_endog.,&j.)"
%end;
%do k=%eval(&nb_endog.+1) %to %eval(&nb_exog.+&nb_endog.) ;
b_&k. = "%scan(&list_exog.,&k.-&nb_endog.)"
%end; 
b0 = "intercept" 
;

log_parts = %do j=1 %to &nb_endog. ; 
		b_&j.*%scan(&list_endog.,&j.) + %end;
			%do k=%eval(&nb_endog.+1) %to %eval(&nb_exog.+&nb_endog.); 
				b_&k.*%scan(&list_exog.,&k.-&nb_endog.) + 	%end;
 
				b0 	;
fit log_parts /  gmm  outest=tab_param;
ods output ParameterEstimates=estimates;
title "gmm estimation, unconstrained model, &nomvariante.";
run; 
  
data  sortieparam;set estimates(keep= demo estimate label  stderr Tvalue   replicate );
where replicate=0 and (label="prixkilomlag3m_m" or label="prix_m" 
%if &nest. =2 %then  or label="log_partsseg" ;
%if &nest. =3 %then  or label="log_partsmod"  or label="log_partsseg"; )
; 
if label = "prix_m" then do;estimate=estimate*10000; stderr=stderr*10000;end;
 
run;
proc sort data=sortieparam;by descending label;
proc export DATA=sortieparam
OUTFILE="\\ulysse\users\givord\@Encours\Petrole\sortiestemporaires\&tab_param..csv"  
DBMS=csv replace; run;


%mend;


   
