options fullstimer;
options BUFSIZE=32k BUFNO=2k;
options compress=yes ; 
libname petrole "\\ulysse\users\givord\@Encours\petrole\tables travail";
libname sorttemp "\\ulysse\users\givord\@Encours\petrole\sortiestemporaires";
/***************************************************************/
/*Macro boostrap (estimation of the elasticities precision)*/  
/*requires macro regression_nested_logit_gmm*/
/***************************************************************/


%macro bootstrap_elasticite(rep=,rep2=, list_exog=,list_endog=,list_inst=,tab_elast=, tab_elast_exemple=, tab_param=,nest=,constraint=,modelcomm=);
   
%global nb;
%global nbpart;
 
proc sql noprint;
	create table modal_demo as
		select distinct demo from petrole.tablespartstvared ; 
	create table modal_demopart as
		select distinct demo from modal_demo where substr(demo,1,1)='0';  
	select count(distinct demo) into :nb from  modal_demo ; 
	select count(distinct demo) into :nbpart from  modal_demopart ;  
quit;

%do i=1 %to &nb.;
%global demo&i.;
%end; 

data modal_demo;
	set modal_demo;
	call symput("demo"||compress(_N_),demo);
run;

%let nb_inst=%sysfunc(countw(&list_inst.)); 
%let nb_endog=%sysfunc(countw(&list_endog.)); 
%let nb_exog=%sysfunc(countw(&list_exog.));  


data data;set  petrole.tablespartstvared (where=((annee<2007 or mois<11) %if &modelcomm.=1 %then and modelcomm=1;)); by demo;
length  marque0-marque15 segment0-segment4 an1-an5 m1-m12 date1-date58 replicate 3.;

datem=(annee-2003)*12+mois;
array date[58] date1-date58;
do i=1 to 58;
date[i]=(datem=i);
end;
array an[5] an1-an5;
do i=1 to 5;
 an[i]=(annee=2002+i);
end; 

array m[12] m1-m12;
do i=1 to 12;
 m[i]=(mois=i);
end; 

prof=(substr(left(demo),1,1)='1');

gasole=(energie='GAZOLE');
sqr_prixkilomlag3m_m=(prixkilomlag3m_m)**(0.5);
marque1=(marque='AUDI');
marque2=(marque='B.M.W.');
marque3=(marque='CITROEN');
marque4=(marque='FIAT');
marque5=(marque='FORD');
marque6=(marque='HYUNDAI');
marque7=(marque='MERCEDES');
marque8=(marque='NISSAN');
marque9=(marque='OPEL');
marque10=(marque='PEUGEOT');
marque11=(marque='SEAT');
marque12=(marque='SUZUKI');
marque13=(marque='TOYOTA');
marque14=(marque='VOLKSWAGEN');
marque15=(marque='RENAULT');
marque0=1-marque1-marque2-marque3-marque4-marque5-marque6-marque7-marque8-marque9-
marque10-marque11-marque12-marque13-marque14-marque15;
segment0=(segment = "TT-TERR");
segment1=(segment = "UTILIT");
segment2=(segment = "MONOSP"); 
segment3=(segment = "CITADINE"); 
segment4=(segment = "COMPACTE"); 
;
replicate =0;  
 
keep &list_endog. &list_inst. &list_exog. log_parts demo /*date1-date57*/ totmod_energ replicate prof ;

run;
 

 
data sortie;
set _null_;length replicate2 3.;run;
 data sortie2;
set _null_;length replicate2 3.;run;
 
%do nrep2=1 %to &rep2;  
proc surveyselect data=data(drop=replicate ) 
method = urs samprate = 1 OUTHITS 
rep=&rep  out=out2(SGIO=yes) ;strata demo; 
run;
proc sort data=out2;by replicate demo;run;

data out(SGIO=yes);merge out2 data ;by replicate;
proc delete data=out2;
 proc freq data=out;tables demo;by replicate; 
run;

%regression_nestedlogit_en(data=out,
list_inst=&list_inst.,list_endog=&list_endog.,list_exog=&list_exog.,
nest=&nest.,tab_param=&tab_param.,nomvariante=tt) ;  
/*sortie estimates utilis pour calcul des lasticits*/
data sorttemp.&tab_param.&nrep2.;set tab_param;replicate2=replicate+(&nrep2.-1)*&rep.;run;
data sortie2;merge sortie2 sorttemp.&tab_param.&nrep2.;by replicate2;
proc delete data=tab_param;
proc delete data=out;run;
%end; 

data sorttemp.&tab_param.;
set sortie2;run;

PROC DATASETS LIB=work KILL NOLIST;run;

%mend;    
   