libname petrole "\\ulysse\users\givord\@Encours\petrole\tables travail";
libname sorties "\\ulysse\users\givord\@Encours\petrole\sorties";
libname sorttemp "\\ulysse\users\givord\@Encours\petrole\sortiestemporaires";

/*Input Data : petrole.prixessence petrole.defcpi petrole.tablesparts  sorttemp.&tab_param.*/
/* Output Data: tab_sortie_model tab_sortie_demo tab_varphi_neuf  tab_varphi_neufco2 tab_partsdiesel_neuf par reutilises macro_bootstrap */
  
/*************************price and tax elasticities estimation ******************/
 

%macro elasticite(tab_param=,tab_sortie_model=,tab_sortie_demo= ,tab_varphi_neuf=,tab_varphi_neufco2=,
 tab_partsdiesel_neuf=,nest=,prixtco2=);
/*parameters*/
proc sql;
create table param_estim as select distinct  replicate2,
%if &nest=3 %then %do;
/*From table param in regression, : prix_m b_1, logpartsseg b_2 logpartsmod b_3 and prixkilom3 b_4*/
b_4 as beta, 
1/(1-b_2) as rho_1, 
1/(1-b_3) as rho_2,  
%end;
%else %if &nest=2 %then %do;
/*From table param in regression, :  prix_m b_1, logpartsseg b_2  et prixkilom3 b_3*/
b_3 as beta, 
1/(1-b_2) as rho_1, 
1 as rho_2,
%end;
%else %if &nest=1 %then %do;
/*From table param in regression, : prix_m b_1, prixkilom3 b_2 */
b_2 as beta, 
1 as rho_1, 
1 as rho_2,
%end;
 demo from sorttemp.&tab_param.  order by  replicate2, demo; 
/* car caracteristics + fuel prices*/
 proc sql;

create table temp as select distinct a.annee, a.mois,demo,  
conso_m,
conso_seg, conso_mod, consodies_seg,consodies_mod,partdiesel_seg,partdiesel_mod,  
 marque,modele,segment,energie,cpi,
(energie="GAZOLE") as gasole,
totmod_energ,  
/*taux de TIPP http://www.ufip.fr/?rubrique=1&ss_rubrique=323&inner=331&ss_inner=403&id=d_52*/
 ((b.annee=2003)*0.3919 
	+(b.annee> 2003 and b.annee<2007)*0.4169
	+(b.annee=2007)* 0.4258)*cpi as t_gazole ,
	( (b.annee<2007)*0.5892
	+(b.annee=2007)* 0.6023)*cpi as t_super 
from 
petrole.tablespartstvared(where=(demo not in ('1_0_B','1_1_B','1_2_B','1_3_B'))) a, petrole.defcpi b where a.annee=b.annee and a.mois=b.mois;
 

create table temp2 as select distinct gazole_lag3m,super98_lag3m , a.*  
from 
temp a, petrole.prixessence b where a.annee=b.annee and a.mois=b.mois ;

create table pourelasticite as select distinct a.*, 
b.conso_moytot,b.partdiesel_tot,b.consodies_tot  
from 
temp2 a, petrole.partsglob_tottvared(where=(demo not in ('1_0_B','1_1_B','1_2_B','1_3_B'))) b where a.annee=b.annee and a.mois=b.mois and a.demo=b.demo 
order by 
a.demo,a.annee,a.mois;
 
data _null_;set temp(where=( annee=2007 and mois=11 )  );
call symput('t_gazole',t_gazole);
call symput('t_super',t_super); 
run; 

%put &t_gazole.;
%put &t_super.;
proc sql;
create table elasticite as select a.demo,
/*prixessence HT*/
a.cpi*((a.gazole_lag3m/100)/1.196)-a.t_gazole as peht 
,a.cpi*((a.super98_lag3m/100)/1.196)-a.t_super as pehtb
,a.conso_m ,a.gasole,a.energie
,a.conso_mod,a.conso_seg
,a.partdiesel_mod,a.consodies_mod,a.partdiesel_seg,a.consodies_seg,
a.marque,a.modele,a.segment,a.totmod_energ,
beta ,rho_1,rho_2
  , replicate2 
from  
  pourelasticite a
, param_estim b where
b.demo =a.demo;

create table pourvariantetaxcarbone as select unique
/*remarque : on utilise directement 2.36=1./0.43*/
/*correspond  du euros par kg*/ 
(&t_super.-&t_gazole.)*

/*remboursement 80% pour diesel pour les prof*/
sum(partdiesel_tot*consodies_tot *tot_tot *((substr(left(demo),1,1)='1')*1.0392/1.196+1-(substr(left(demo),1,1)='1') ))  /
/*co2moyen , on tient compte du fait que conso est en l/100km */
sum(tot_tot*( 
/*remboursement 80% pour diesel pour les prof*/
(1-(substr(left(demo),1,1)='1'))* (conso_moytot*2.63*partdiesel_tot+ conso_moytot*2.33*(1-partdiesel_tot))
+(substr(left(demo),1,1)='1')* ((conso_moytot+consodies_tot*partdiesel_tot*(1.0392/1.196-1)) *2.63*partdiesel_tot+
                   (conso_moytot+consodies_tot*partdiesel_tot*(1.0392/1.196-1))*2.33*(1-partdiesel_tot)) ))
as tcarboneontop 
,&t_super. as tegal1
 
from petrole.Partsglob_tot/*1demo*/tvared(where=( annee=2007 and mois=11 and demo not in ('1_0_B','1_1_B','1_2_B','1_3_B')
)  )
 ;
 


data _null_;set pourvariantetaxcarbone;
call symput('tcarboneontop',tcarboneontop);
call symput('tegal1',tegal1);

run;

proc delete data=temp temp2 pourelasticite param_estim pourvariantetaxcarbone; run;  
 
data  elasticite;set elasticite;  
/*en g /km*/ 
if gasole=0 /*energie="ESSENCE"*/ then co2= conso_m/0.043;/* =23.3 , on tient compte du fait que conso est en l/100km*/
if gasole /*energie="GAZOLE"*/ then co2=conso_m/0.038; 
prof=1*(substr(demo,1,1)='1'); 

/* */

/*on drive parts de marche p/r  une taxe/prix qui touche identiquement diesel et essence*/
/*Name conventions*/
/*conso_m : conso au km pour le modele j energie k d'une demo ; 
  conso_mod : conso au km moyenne pour le modele j d'une demo 
  consodies_mod conso au km moyenne pour la version diesel du modele j d'une demo 
  cons_seg : conso au km moyenne du segment d'une demo 
  consodies_seg conso au km moyenne pour la version diesel dans un segment d'une demo 	
  conso_moytot : conso au km moyenne d'une demo 
  consodies_tot	conso au km moyenne pour la version diesel   d'une demo 	*/
/*partdiesel_mod : pour un modle j d'une demo
partdiesel_seg : pour un segment d'une demo
partdiesel_tot : pour  une demo
  */
 
/*remboursement 80% pour diesel pour les prof*/
		nu_id=beta *(
		(1-prof)*(rho_1*(conso_m-conso_mod)+rho_2*(conso_mod-conso_seg)+conso_seg)
/*remboursement 80% pour diesel pour les prof: equivalent conso*1.0392/1.196, mais il faut tenir compte dans les conso agrgs par modele et segment **/ 
		+ prof*(
 				rho_1*(conso_m*1.0392/1.196-(conso_mod +partdiesel_mod*consodies_mod *(1.0392/1.196-1)))
 		 		+rho_2*((conso_mod +partdiesel_mod*consodies_mod *(1.0392/1.196-1))-( conso_seg +partdiesel_seg*consodies_seg *(1.0392/1.196-1) ))
  				+conso_seg +partdiesel_seg*consodies_seg *(1.0392/1.196-1)
				 )
				 )*peht*1.196;  
	/*TIPP diesel*/ 
		nu_tippd=beta* (
				(1-prof)*(
							rho_1*(conso_m*gasole-partdiesel_mod*consodies_mod )
							+rho_2*(partdiesel_mod*consodies_mod-partdiesel_seg*consodies_seg) 
							+partdiesel_seg*consodies_seg 
							)
                +prof *(
						rho_1*(conso_m*gasole-partdiesel_mod*consodies_mod )
						+rho_2*(partdiesel_mod*consodies_mod-partdiesel_seg*consodies_seg) 
						+partdiesel_seg*consodies_seg 
						)*1.0392/1.196
						);
/*on doit trouver nu_tippd = nu egal1 */

								/*taxe egal _variante1 : egalisation taux diesel essence, plus de reduc tva diesel*/ 
			simu_tegvar1=beta*(
						(1-prof)*(
								(rho_1*(conso_m*gasole-partdiesel_mod*consodies_mod)+ 
								rho_2*(partdiesel_mod*consodies_mod-partdiesel_seg*consodies_seg)		
								+partdiesel_seg*consodies_seg )*(&tegal1.-&t_gazole.) 
								)
						+prof*(
				(rho_1*(conso_m*gasole-partdiesel_mod*consodies_mod)+ 
				rho_2*(partdiesel_mod*consodies_mod-partdiesel_seg*consodies_seg)		
								+partdiesel_seg*consodies_seg )*((&tegal1.-&t_gazole.) +(1-1.0392/1.196)*(&t_gazole.+peht))
				/*+(rho_1*(conso_m*(1-gasole)-(conso_mod-partdiesel_mod*consodies_mod))+ 
				rho_2*((conso_mod-partdiesel_mod*consodies_mod)-(conso_seg-consodies_seg *partdiesel_seg))		
								+(conso_seg-consodies_seg *partdiesel_seg))*(&tegal1.-&t_super.)*/
								)
							)*100*1.196;

								/*taxe egal _variante2 : egalisation taux diesel essence,  reduc tva diesel et essence pour les deux*/ 
			simu_tegvar2=beta*(
					(1-prof)*(
				(rho_1*(conso_m*gasole-partdiesel_mod*consodies_mod)+ 
				rho_2*(partdiesel_mod*consodies_mod-partdiesel_seg*consodies_seg)		
								+partdiesel_seg*consodies_seg )*(&tegal1.-&t_gazole.) 
				+(rho_1*(conso_m*(1-gasole)-(conso_mod-partdiesel_mod*consodies_mod))+ 
				rho_2*((conso_mod-partdiesel_mod*consodies_mod)-(conso_seg-consodies_seg *partdiesel_seg))		
								+(conso_seg-consodies_seg *partdiesel_seg))*(&tegal1.-&t_super.)
								)
					+prof*(	
				(rho_1*(conso_m*gasole-partdiesel_mod*consodies_mod)+ 
				rho_2*(partdiesel_mod*consodies_mod-partdiesel_seg*consodies_seg)		
								+partdiesel_seg*consodies_seg )*(&tegal1.-&t_gazole.) * 1.0392 /1.196
				+(rho_1*(conso_m*(1-gasole)-(conso_mod-partdiesel_mod*consodies_mod))+ 
				rho_2*((conso_mod-partdiesel_mod*consodies_mod)-(conso_seg-consodies_seg *partdiesel_seg))		
								+(conso_seg-consodies_seg *partdiesel_seg)) *((1.0392/1.196-1)*(&t_super.+pehtb))
						    )
									)*100* 1.196;
 
			/*taxe carbone*/ 
			simu_tc=beta*(
				(rho_1*(conso_m*gasole-partdiesel_mod*consodies_mod)+ 
				rho_2*(partdiesel_mod*consodies_mod-partdiesel_seg*consodies_seg)		 
						+partdiesel_seg*consodies_seg )*2.63*&prixtco2./1000
				+(rho_1*(conso_m*(1-gasole)-(conso_mod-partdiesel_mod*consodies_mod))+ 
				rho_2*((conso_mod-partdiesel_mod*consodies_mod)-(conso_seg-consodies_seg *partdiesel_seg))	 
								+(conso_seg-consodies_seg *partdiesel_seg))*2.33*&prixtco2./1000
					)*100*1.196; 		

					/*taxe carbone on top : on supprime abattement TVA sur gasole*/ 
					simu_tcontop=beta*(
				(rho_1*(conso_m*gasole-partdiesel_mod*consodies_mod)+ 
				rho_2*(partdiesel_mod*consodies_mod-partdiesel_seg*consodies_seg)		 
						+partdiesel_seg*consodies_seg )*2.63*&tcarboneontop.
				+(rho_1*(conso_m*(1-gasole)-(conso_mod-partdiesel_mod*consodies_mod))+ 
				rho_2*((conso_mod-partdiesel_mod*consodies_mod)-(conso_seg-consodies_seg *partdiesel_seg))	 
								+(conso_seg-consodies_seg *partdiesel_seg))*2.33*&tcarboneontop.
					)*100*1.196; 

					/*taxe carbone on top : on conserve abattement TVA sur gasole*/ 
					simu_tcontop2=beta*( 
				  			(
								rho_1*(conso_m*gasole-partdiesel_mod*consodies_mod)+ 
								rho_2*(partdiesel_mod*consodies_mod-partdiesel_seg*consodies_seg)		
				 
								+partdiesel_seg*consodies_seg 
							)*2.63*&tcarboneontop.*(1.0392/1.196*prof+(1-prof))		/*tva rduite pour le diesel pour les prof*/ 	
     						+(
								rho_1*(conso_m*(1-gasole)-(conso_mod-partdiesel_mod*consodies_mod))+ 
								rho_2*((conso_mod-partdiesel_mod*consodies_mod)-(conso_seg-consodies_seg *partdiesel_seg))		
					 
								+(conso_seg-consodies_seg *partdiesel_seg)
							)*2.33*&tcarboneontop.
     									)*100*1.196; 


run;
 
/*calcul de l'lasticit pour certains modeles reprsentatifs*/
data modeleexemples;set elasticite;
where   (marque = "RENAULT" and modele="TWINGO"  ) or 
(marque = "PEUGEOT" and modele="307" and segment="SPORT"  ) or  
(marque = "CITROEN" and modele="C3"  ) or  
(marque = "AUDI" and modele="A6" and segment="BERLINE"  )
 ;
run; 

proc sql; 

create table elast_exemples as select unique
replicate2,
marque, modele ,energie,segment,  
sum(totmod_energ*conso_m)/sum(totmod_energ)
						  as phi_moy , 
					 sum(totmod_energ*co2)/sum(totmod_energ)
						  as co2_moy , 
sum(nu_id*totmod_energ)/sum(totmod_energ) as nu_id_moy,
sum(nu_tippd*totmod_energ)/sum(totmod_energ) as nu_tippd_moy, 
sum(simu_tc*totmod_energ)/sum(totmod_energ) as simu_tc_moy , 
sum(simu_tcontop*totmod_energ)/sum(totmod_energ) as simu_tcontop_moy , 
sum(simu_tcontop2*totmod_energ)/sum(totmod_energ) as simu_tcontop2_moy , 
sum(simu_tegvar1*totmod_energ)/sum(totmod_energ) as simu_tegvar1_moy , 
sum(simu_tegvar2*totmod_energ)/sum(totmod_energ) as simu_tegvar2_moy /*, 
sum(simu_tegvar3*totmod_energ)/sum(totmod_energ) as simu_tegvar3_moy */
from modeleexemples
group by 
replicate2, marque, modele, energie,segment 
order  by 
replicate2, marque, modele, energie,segment ; 


data elast_exemples;set elast_exemples;
/*elasticite au prix de l'essence*/
rename nu_id_moy=  elast_pe;
/*on aligne tipp diesel sur niveau tipp_super*/
simutaxdieselold= nu_tippd_moy*(0.6023-0.4258)*100 * /*1+tva*/1.196;
simutaxdiesel= nu_tippd_moy*(&t_super.-&t_gazole.)*100 * /*1+tva*/1.196;
drop nu_tippd_moy; 
run;


title 'lasticit moyenne pour certains vhicules';
proc print data=elast_exemples;run;
/*
PROC EXPORT DATA= WORK.elast_exemples
            OUTFILE= "u:\Petrole\sorties\&tab_sortie_model." 
            DBMS=EXCEL5 REPLACE;
RUN;*/
 

/***********************************************************************************/
           /*effet sur la consommation moyenne des vhicules neufs*/

 

proc sql;
 /*agrg prof /particulier*/
create table varphiagneuf_t as select distinct 
replicate2, prof ,
/*elasticit demo par demo, mois par mois*/
/*sum(totmod_energ*nu_id*conso_m)/(sum(totmod_energ)*conso_moytot)
						-sum(totmod_energ*nu0_id)/sum(totmod_energ) as varphi_id_demo, */
sum(totmod_energ*conso_m)/sum(totmod_energ)
						  as phi_moy , 
sum(totmod_energ*nu_id*conso_m)/sum(totmod_energ*conso_m)
						-sum(totmod_energ*nu_id)/sum(totmod_energ)  as varphi_id , 
sum(totmod_energ*nu_tippd*conso_m )/sum(totmod_energ*conso_m)
						-sum(totmod_energ*nu_tippd)/sum(totmod_energ)  as varphi_tipp ,
sum(totmod_energ*simu_tegvar1*conso_m )/sum(totmod_energ*conso_m)
						-sum(totmod_energ*simu_tegvar1)/sum(totmod_energ)  as varphi_simutegvar1 ,
sum(totmod_energ*simu_tegvar2*conso_m )/sum(totmod_energ*conso_m)
						-sum(totmod_energ*simu_tegvar2)/sum(totmod_energ)  as varphi_simutegvar2 ,/*
sum(totmod_energ*simu_tegvar3*conso_m )/sum(totmod_energ*conso_m)
						-sum(totmod_energ*simu_tegvar3)/sum(totmod_energ)  as varphi_simutegvar3 ,*/
sum(totmod_energ*simu_tc*conso_m )/sum(totmod_energ*conso_m)
						-sum(totmod_energ*simu_tc)/sum(totmod_energ)  as varphi_simutc ,
sum(totmod_energ*simu_tcontop*conso_m )/sum(totmod_energ*conso_m)
						-sum(totmod_energ*simu_tcontop)/sum(totmod_energ)  as varphi_simutcontop  ,
sum(totmod_energ*simu_tcontop2*conso_m )/sum(totmod_energ*conso_m)
						-sum(totmod_energ*simu_tcontop2)/sum(totmod_energ)  as varphi_simutcontop2
from elasticite 
group by 
replicate2,prof;

create table varphiagneuf_total as select distinct . as prof ,
replicate2,
/*elasticit demo par demo, mois par mois*/
sum(totmod_energ*conso_m)/sum(totmod_energ)
						  as phi_moy , 
sum(totmod_energ*nu_id*conso_m)/sum(totmod_energ*conso_m)
						-sum(totmod_energ*nu_id)/sum(totmod_energ)  as varphi_id , 
sum(totmod_energ*nu_tippd*conso_m )/sum(totmod_energ*conso_m)
						-sum(totmod_energ*nu_tippd)/sum(totmod_energ)  as varphi_tipp, 
sum(totmod_energ*simu_tegvar1*conso_m )/sum(totmod_energ*conso_m)
						-sum(totmod_energ*simu_tegvar1)/sum(totmod_energ)  as varphi_simutegvar1 , 
sum(totmod_energ*simu_tegvar2*conso_m )/sum(totmod_energ*conso_m)
						-sum(totmod_energ*simu_tegvar1)/sum(totmod_energ)  as varphi_simutegvar2 ,  
sum(totmod_energ*simu_tc*conso_m )/sum(totmod_energ*conso_m)
						-sum(totmod_energ*simu_tc)/sum(totmod_energ)  as varphi_simutc , 
sum(totmod_energ*simu_tcontop*conso_m )/sum(totmod_energ*conso_m)
						-sum(totmod_energ*simu_tcontop)/sum(totmod_energ)  as varphi_simutcontop  , 
sum(totmod_energ*simu_tcontop2*conso_m )/sum(totmod_energ*conso_m)
						-sum(totmod_energ*simu_tcontop2)/sum(totmod_energ)  as varphi_simutcontop2 
from elasticite 
group by replicate2  ;
 
 proc sql;
create table varphiagneuf_pp as select unique  prof,
replicate2,
  phi_moy , 
varphi_id  as varphi_pe_agtot	 
,varphi_tipp *(&t_super.-&t_gazole.)*100 * 1.196  as varphi_simutaxdiesel_agtot ,
 varphi_simutegvar1  as varphi_simutegvar1_agtot,
 varphi_simutegvar2  as varphi_simutegvar2_agtot ,/*
 varphi_simutegvar3  as varphi_simutegvar3_agtot,*/
varphi_simutc  as varphi_simutc_agtot,
 varphi_simutcontop  as varphi_simutcontop_agtot,
 varphi_simutcontop2  as varphi_simutcontop2_agtot
from varphiagneuf_t 
order by replicate2, prof;
 
create table varphiagtotalneuf as select unique  prof,
replicate2,
 phi_moy , 
varphi_id  as varphi_pe_agtot	
,varphi_tipp *(&t_super.-&t_gazole.)*100 * 1.196  as varphi_simutaxdiesel_agtot  
,varphi_simutegvar1  as varphi_simutegvar1_agtot
,varphi_simutegvar2  as varphi_simutegvar2_agtot/*
,varphi_simutegvar3  as varphi_simutegvar3_agtot*/
,varphi_simutc  as varphi_simutc_agtot
,varphi_simutcontop  as varphi_simutcontop_agtot
,varphi_simutcontop2  as varphi_simutcontop2_agtot 
from varphiagneuf_total ;

data varphiagneuf;merge varphiagneuf_pp varphiagtotalneuf;by 
 replicate2 prof;run; 

 
/*par catgorie demo, agrg sur l'ensemble des dates*/  
 proc sql;
 /*agrg prof /particulier*/
create table varphiagneufco2_t as select distinct 
replicate2, prof ,
/*elasticit demo par demo, mois par mois*/
sum(totmod_energ*co2)/sum(totmod_energ)
						  as phico2_moy , 
sum(totmod_energ*nu_id*co2)/sum(totmod_energ*co2)
						-sum(totmod_energ*nu_id)/sum(totmod_energ)  as varphico2_id , 
sum(totmod_energ*nu_tippd*co2 )/sum(totmod_energ*co2)
						-sum(totmod_energ*nu_tippd)/sum(totmod_energ)  as varphico2_tipp, 				
sum(totmod_energ*simu_tegvar1*co2 )/sum(totmod_energ*co2)
						-sum(totmod_energ*simu_tegvar1)/sum(totmod_energ)  as varphico2_simutegvar1, 		
sum(totmod_energ*simu_tegvar2*co2 )/sum(totmod_energ*co2)
						-sum(totmod_energ*simu_tegvar2)/sum(totmod_energ)  as varphico2_simutegvar2,  					
sum(totmod_energ*simu_tc*co2 )/sum(totmod_energ*co2)
						-sum(totmod_energ*simu_tc)/sum(totmod_energ)  as varphico2_simutc, 							
sum(totmod_energ*simu_tcontop*co2 )/sum(totmod_energ*co2)
						-sum(totmod_energ*simu_tcontop)/sum(totmod_energ)  as varphico2_simutcontop, 							
sum(totmod_energ*simu_tcontop2*co2 )/sum(totmod_energ*co2)
						-sum(totmod_energ*simu_tcontop2)/sum(totmod_energ)  as varphico2_simutcontop2
from elasticite 
group by 
replicate2, prof;

create table varphiagneufco2_total as select distinct . as prof ,
replicate2,  
sum(totmod_energ*co2)/sum(totmod_energ)
						  as phico2_moy , 
sum(totmod_energ*nu_id*co2)/sum(totmod_energ*co2)
						-sum(totmod_energ*nu_id)/sum(totmod_energ)  as varphico2_id , 

sum(totmod_energ*nu_tippd*co2 )/sum(totmod_energ*co2)
						-sum(totmod_energ*nu_tippd)/sum(totmod_energ)  as varphico2_tipp ,
sum(totmod_energ*simu_tegvar1*co2 )/sum(totmod_energ*co2)
						-sum(totmod_energ*simu_tegvar1)/sum(totmod_energ)  as varphico2_simutegvar1, 
sum(totmod_energ*simu_tegvar2*co2 )/sum(totmod_energ*co2)
						-sum(totmod_energ*simu_tegvar2)/sum(totmod_energ)  as varphico2_simutegvar2,  
sum(totmod_energ*simu_tc*co2 )/sum(totmod_energ*co2)
						-sum(totmod_energ*simu_tc)/sum(totmod_energ)  as varphico2_simutc,
sum(totmod_energ*simu_tcontop*co2 )/sum(totmod_energ*co2)
						-sum(totmod_energ*simu_tcontop)/sum(totmod_energ)  as varphico2_simutcontop,
sum(totmod_energ*simu_tcontop2*co2 )/sum(totmod_energ*co2)
						-sum(totmod_energ*simu_tcontop2)/sum(totmod_energ)  as varphico2_simutcontop2

from elasticite   
group by replicate2 ;
 
create table varphiagneufco2_pp as select unique 
replicate2, prof,
phico2_moy ,
varphico2_id  as varphico2_pe_agtot	
,varphico2_tipp *(&t_super.-&t_gazole.)*100 * 1.196  as varphico2_simutaxdiesel_agtot  
  ,varphico2_simutegvar1 as varphico2_simutegvar1_agtot
  ,varphico2_simutegvar2 as varphico2_simutegvar2_agtot 
 ,varphico2_simutc as varphico2_simutc_agtot
 ,varphico2_simutcontop as varphico2_simutcontop_agtot
 ,varphico2_simutcontop2 as varphico2_simutcontop2_agtot
from varphiagneufco2_t ;
 
create table varphiagtotalneufco2 as select unique 
replicate2, prof,
phico2_moy ,
varphico2_id  as varphico2_pe_agtot	
,varphico2_tipp *(&t_super.-&t_gazole.)*100 * 1.196  as varphico2_simutaxdiesel_agtot  
   ,varphico2_simutegvar1 as varphico2_simutegvar1_agtot
   ,varphico2_simutegvar2 as varphico2_simutegvar2_agtot
 ,varphico2_simutc as varphico2_simutc_agtot
 ,varphico2_simutcontop as varphico2_simutcontop_agtot
 ,varphico2_simutcontop2 as varphico2_simutcontop2_agtot
from varphiagneufco2_total ;

 
data varphiagneufco2;merge varphiagneufco2_pp varphiagtotalneufco2;by 
 replicate2  prof;run;
     

/***********************************************************************************/
/****************************Diesel share*/
/*by demo, month by month*/ 


/*agrege*/

proc sql;
create table varpartsdieselagneuf_t as select unique 
replicate2,
prof, 
/*elasticit demo par demo, mois par mois*/

sum(totmod_energ*gasole)/sum(totmod_energ)   as PartDiesel, 
sum(totmod_energ*nu_id*gasole)/sum(totmod_energ*gasole) 
						- sum(totmod_energ*nu_id)/sum(totmod_energ)  as PId_id, 
 sum(totmod_energ*nu_tippd*gasole)/sum(totmod_energ*gasole) 
						- sum(totmod_energ*nu_tippd)/sum(totmod_energ)  as PId_tipp,
sum(totmod_energ*simu_tegvar1*gasole )/sum(totmod_energ*gasole)
						-sum(totmod_energ*simu_tegvar1)/sum(totmod_energ)  as PId_simutegvar1 ,
sum(totmod_energ*simu_tegvar2*gasole )/sum(totmod_energ*gasole)
						-sum(totmod_energ*simu_tegvar2)/sum(totmod_energ)  as PId_simutegvar2 , 

sum(totmod_energ*simu_tc*gasole )/sum(totmod_energ*gasole)
						-sum(totmod_energ*simu_tc)/sum(totmod_energ)  as PId_simutc ,
sum(totmod_energ*simu_tcontop*gasole )/sum(totmod_energ*gasole)
						-sum(totmod_energ*simu_tcontop)/sum(totmod_energ)  as PId_simutcontop  ,
sum(totmod_energ*simu_tcontop2*gasole )/sum(totmod_energ*gasole)
						-sum(totmod_energ*simu_tcontop2)/sum(totmod_energ)  as PId_simutcontop2 
from elasticite 
group by 
replicate2, prof ;

create table varpartsdieselagneuf_total as select unique 
. as prof, 
replicate2,
/*elasticit demo par demo, mois par mois*/

sum(totmod_energ*gasole)/sum(totmod_energ)   as PartDiesel, 
sum(totmod_energ*nu_id*gasole)/sum(totmod_energ*gasole) 
						- sum(totmod_energ*nu_id)/sum(totmod_energ)  as PId_id, 
 sum(totmod_energ*nu_tippd*gasole)/sum(totmod_energ*gasole) 
						- sum(totmod_energ*nu_tippd)/sum(totmod_energ)  as PId_tipp,
sum(totmod_energ*simu_tegvar1*gasole )/sum(totmod_energ*gasole)
						-sum(totmod_energ*simu_tegvar1)/sum(totmod_energ)  as PId_simutegvar1 ,
sum(totmod_energ*simu_tegvar2*gasole )/sum(totmod_energ*gasole)
						-sum(totmod_energ*simu_tegvar2)/sum(totmod_energ)  as PId_simutegvar2 , 
sum(totmod_energ*simu_tc*gasole )/sum(totmod_energ*gasole)
						-sum(totmod_energ*simu_tc)/sum(totmod_energ)  as PId_simutc,
sum(totmod_energ*simu_tcontop*gasole )/sum(totmod_energ*gasole)
						-sum(totmod_energ*simu_tcontop)/sum(totmod_energ)  as PId_simutcontop,
sum(totmod_energ*simu_tcontop2*gasole )/sum(totmod_energ*gasole)
						-sum(totmod_energ*simu_tcontop2)/sum(totmod_energ)  as PId_simutcontop2
from elasticite
group by replicate2 ; 
  

/*par prof/part, sur l'ensemble de la priode*/
create table partsdieselprofpartneuf as select unique  
replicate2,
 PartDiesel,	
  PId_simutegvar1 as PId_simutegvar1_agtot ,
  PId_simutegvar2 as PId_simutegvar2_agtot , 
PId_simutc as PId_simutc_agtot ,
PId_simutcontop as PId_simutcontop_agtot ,
PId_simutcontop2 as PId_simutcontop2_agtot ,
prof,PId_id as PId_peht_agtot	 
,PId_tipp*(&t_super.-&t_gazole.)*100 * 1.196 
							as PId_simutaxdiesel_agtot 
from varpartsdieselagneuf_t ;


/*par prof/part, sur l'ensemble de la priode*/
create table partsdieseltotalneuf as select unique  
replicate2,
 PartDiesel,
  PId_simutegvar1 as PId_simutegvar1_agtot ,
  PId_simutegvar2 as PId_simutegvar2_agtot , 
PId_simutc as PId_simutc_agtot ,
PId_simutcontop as PId_simutcontop_agtot,
PId_simutcontop2 as PId_simutcontop2_agtot,
prof,PId_id as PId_peht_agtot	  
,PId_tipp*(&t_super.-&t_gazole.)*100 * 1.196 
							as PId_simutaxdiesel_agtot 
from varpartsdieselagneuf_total ;

data partsdieselneuf;merge partsdieseltotalneuf partsdieselprofpartneuf;by 
replicate2 prof;run;


%mend; 
 
