options fullstimer;
options BUFSIZE=32k BUFNO=2k;
options compress=yes ;
/* Pour le calcul des instruments */
libname petrole "\\ulysse\users\givord\@Encours\Petrole\tables travail";
libname sorttemp "\\ulysse\users\givord\@Encours\Petrole\sortiestemporaires";
/***************************************************************/
/*Macro pour le boostrap pour calcul prcision lasticit*/
/*; principe : on tire une grande table et ob fait des estimations par strates (variable replicate)*/
/***************************************************************/

 
%macro intval(data=,var=,exemple=,sortie=);

%if &exemple.=1 %then %do;
proc sort data=&data.( keep=  marque modele energie segment &var replicate  ) out=temp; 
by marque modele energie segment ; ;
/*data temp ;set  &data.( keep=&strat &var replicate  )  ; out=temp; 
by &strat.;*/
 %end;
%else %do;data temp;set &data.(keep=  &var replicate  );;%end;


data sorprinc; set temp(    where=(replicate=0));

/*calcul de l'intervalle de confiance*/ 
proc univariate data=temp(   where=(replicate>0)) noprint; 
output out=intval std=std pctlpts=2.5 97.5 pctlpre=p_ ;
var &var.;%if &exemple.=1 %then by marque modele energie segment;;run;

data &sortie.  ;
length var $20.;
merge intval sorprinc; %if &exemple.=1 %then by marque modele energie segment;;
drop replicate;
Var= "&var.";
rename &var. =EST; 
run;
proc print data=&sortie.;run;
proc delete data=intval;
proc delete data=sorprinc;run;
%mend; 


  

%macro bootstrap_elasticite_1demo( rep=, list_exog=,list_endog=,list_inst=, 
tab_elast=, tab_elast_exemple=, tab_param=,nest=,modelcomm=);

%let nb_inst=%sysfunc(countw(&list_inst.)); 
%let nb_endog=%sysfunc(countw(&list_endog.)); 
%let nb_exog=%sysfunc(countw(&list_exog.));  


data data;set  petrole.tablesparts1demotvared (where=((annee<2007 or mois<11) %if &modelcomm.=1 %then and modelcomm=1;)); 
length  marque0-marque15 segment0-segment4 an1-an5 m1-m12 date1-date58 replicate 3.;

datem=(annee-2003)*12+mois;
array date[58] date1-date58;
do i=1 to 58;
date[i]=(datem=i);
end;
array an[5] an1-an5;
do i=1 to 5;
 an[i]=(annee=2002+i);
end; 

array m[12] m1-m12;
do i=1 to 12;
 m[i]=(mois=i);
end; 

gasole=(energie='GAZOLE');
sqr_prixkilomlag3m_m=(prixkilomlag3m_m)**(0.5);
marque1=(marque='AUDI');
marque2=(marque='B.M.W.');
marque3=(marque='CITROEN');
marque4=(marque='FIAT');
marque5=(marque='FORD');
marque6=(marque='HYUNDAI');
marque7=(marque='MERCEDES');
marque8=(marque='NISSAN');
marque9=(marque='OPEL');
marque10=(marque='PEUGEOT');
marque11=(marque='SEAT');
marque12=(marque='SUZUKI');
marque13=(marque='TOYOTA');
marque14=(marque='VOLKSWAGEN');
marque15=(marque='RENAULT');
marque0=1-marque1-marque2-marque3-marque4-marque5-marque6-marque7-marque8-marque9-
marque10-marque11-marque12-marque13-marque14-marque15;
segment0=(segment = "TT-TERR");
segment1=(segment = "UTILIT");
segment2=(segment = "MONOSP"); 
segment3=(segment = "CITADINE"); 
segment4=(segment = "COMPACTE"); 
;
replicate =0;  
keep &list_endog. &list_inst. &list_exog. log_parts /*demo /*date1-date57*/ totmod_energ replicate ;
run;

/*tirage*/
proc surveyselect data=data(drop=replicate ) 
method = urs samprate = 1 OUTHITS 
rep=&rep  out=out2(SGIO=yes) ;/*strata demo; */
run;
proc sort data=out2;by replicate /*demo*/;run;

data out(SGIO=yes);merge out2 data ;by replicate;
proc delete data=out2;
 /*proc freq data=out;tables demo;by replicate; 
run;*/

option mprint; 
%regression_nestedlogit_en1demo(data=out,
list_inst=&list_inst.,list_endog=&list_endog.,list_exog=&list_exog.,
 tab_param=&tab_param.,nomvariante=tt, nest=&nest.) ;
/*
option mprint; 
%elasticite_1demo(tab_param=&tab_param.,nest=&nest.);
 
%intval(data=elast_exemples,exemple=1,
var=elast_pe,
sortie=elast_exemples1);
%intval(data=elast_exemples,exemple=1,
var=simutaxdiesel,sortie=elast_exemples2 ); 
%intval(data=elast_exemples,exemple=1,
var=simu_tc_moy,sortie=elast_exemples3 ); 
%intval(data=elast_exemples,exemple=1,
var=co2_moy,sortie=elast_exemples4 ); 
%intval(data=elast_exemples,exemple=1,
var=phi_moy,sortie=elast_exemples5);

%intval(data=varphiagneuf, var=varphi_pe_agtot,exemple=0,
sortie=varphi_pe_agtot);
%intval(data=varphiagneuf, var=varphi_simutaxdiesel_agtot,exemple=0,
sortie=varphi_simutaxdiesel_agtot);  
%intval(data=varphiagneuf, var=varphi_simutc_agtot,exemple=0,
sortie=varphi_simutc_agtot); 

%intval(data=varphiagneufco2, var=varphico2_pe_agtot,exemple=0,
sortie =varphic02_pe_agtot);
%intval(data=varphiagneufco2, var=varphico2_simutaxdiesel_agtot,exemple=0,
sortie=varphic02_simutaxdiesel_agtot); 
%intval(data=varphiagneufco2, var=varphico2_simutc_agtot,exemple=0,
sortie=varphic02_simutc_agtot); 
 

%intval(data=partsdieselneuf,var=PId_peht_agtot,exemple=0,
sortie=PId_peht_agtot);
%intval(data=partsdieselneuf,var=PId_simutaxdiesel_agtot,exemple=0,
sortie=PId_simutaxdiesel_agtot); 
%intval(data=partsdieselneuf,var=PId_simutc_agtot,exemple=0,
sortie=PId_simutc_agtot); 

data temp;merge varphi_simutaxdiesel_agtot varphi_simutc_agtot  varphi_pe_agtot 
varphic02_simutaxdiesel_agtot varphic02_simutc_agtot varphic02_pe_agtot 
PId_simutaxdiesel_agtot PId_simutc_agtot  PId_peht_agtot ;
by var;run;
  
proc export DATA=temp
OUTFILE="\\ulysse\users\givord\@Encours\Petrole\sortiestemporaires\&tab_elast..csv"  
DBMS=csv replace; run;

data exemples;merge elast_exemples1 elast_exemples2 elast_exemples3 elast_exemples4 elast_exemples5 ;
by var;run;
proc export DATA=exemples
OUTFILE="\\ulysse\users\givord\@Encours\Petrole\sortiestemporaires\&tab_elast_exemple..csv"  
DBMS=csv replace; run;
*/ 
proc delete data=exemples ;
proc delete data=temp ;run;
 
proc delete data=out ;run;

%mend;    
