options fullstimer;
options BUFSIZE=32k BUFNO=2k;
options compress=yes ; 
/***************************************************************/ 
/***************************************************************/
 
%macro intval(data=,indicstrat=,var=,strat=,sortie=,rep=,rep2=);

%if &strat.= %then %do ;
data temp;set &data.( keep=&strat &var replicate2 );
%end; 
%else %do ;
proc sort data=&data.( keep=&strat &var replicate2 ) out=temp; 
by &strat.; 
%end;
;

data sorprinc; set temp(    where=(replicate2=0));

/*calcul de l'intervalle de confiance*/ 
proc univariate data=temp(   where=(replicate2 not in (0 %do k = 1 %to &rep2.; ,%eval(&k.*&rep.) %end;))) noprint; 
output out=intval std=std pctlpts=2.5 97.5 pctlpre=p_ ;
var &var.;
%if &strat. ne   %then by &strat.;;
run;

data &sortie.  ;
length var $30.;
merge intval sorprinc;
%if &strat. ne   %then by &strat.;;
drop replicate2;
Var= "&var.";
rename &var. =EST; 
run;
proc print data=&sortie.;run;
proc delete data=intval;
proc delete data=sorprinc;run;
%mend; 

/*MAj et 2015 on ne relance pas les regressions mais on utilise les tables dj construites*/

%macro sortie_elasticite(tab_elast=, tab_elast_exemple=, tab_param=,nest=,prixtco2=,rep=,rep2=);
  


%elasticite(tab_param=&tab_param.,nest=&nest.,prixtco2=&prixtco2.);

%intval(data=elast_exemples,strat=marque modele energie segment,
var=elast_pe,
sortie=elast_exemples1,rep=&rep.,rep2=&rep2.);
%intval(data=elast_exemples,strat=marque modele energie segment,
var=simutaxdiesel,sortie=elast_exemples2,rep=&rep.,rep2=&rep2. ); 
%intval(data=elast_exemples,strat=marque modele energie segment,
var=simu_tegvar1_moy,sortie=elast_exemples2a,rep=&rep.,rep2=&rep2. ); /*
%intval(data=elast_exemples,strat=marque modele energie segment,
var=simu_tegvar2_moy,sortie=elast_exemples2b,rep=&rep.,rep2=&rep2. ); 
%intval(data=elast_exemples,strat=marque modele energie segment,
var=simu_tegvar3_moy,sortie=elast_exemples2c,rep=&rep.,rep2=&rep2. ); */
%intval(data=elast_exemples,strat=marque modele energie segment,
var=simu_tc_moy,sortie=elast_exemples3,rep=&rep.,rep2=&rep2. ); 
%intval(data=elast_exemples,strat=marque modele energie segment,
var=simu_tcontop_moy,sortie=elast_exemples3ot,rep=&rep.,rep2=&rep2. ); /*
%intval(data=elast_exemples,strat=marque modele energie segment,
var=simu_tcvar1_moy,sortie=elast_exemples3a,rep=&rep.,rep2=&rep2. ); 
%intval(data=elast_exemples,strat=marque modele energie segment,
var=simu_tcvar2_moy,sortie=elast_exemples3b,rep=&rep.,rep2=&rep2. ); 
%intval(data=elast_exemples,strat=marque modele energie segment,
var=simu_tcvar3_moy,sortie=elast_exemples3c,rep=&rep.,rep2=&rep2. ); */
%intval(data=elast_exemples,strat=marque modele energie segment,
var=co2_moy,sortie=elast_exemples4,rep=&rep.,rep2=&rep2. ); 
%intval(data=elast_exemples,strat=marque modele energie segment,
var=phi_moy,sortie=elast_exemples5,rep=&rep.,rep2=&rep2.); 
 
%intval(data=varphiagtotalneuf, strat=,var=varphi_pe_agtot,
sortie=varphi_pe_agtot,rep=&rep.,rep2=&rep2.);
%intval(data=varphiagtotalneuf,  strat=,var=varphi_simutaxdiesel_agtot,
sortie=varphi_simutaxdiesel_agtot,rep=&rep.,rep2=&rep2.);  
%intval(data=varphiagtotalneuf,  strat=,var=varphi_simutegvar1_agtot,
sortie=varphi_simutegvar1_agtot,rep=&rep.,rep2=&rep2.); /*
%intval(data=varphiagneuf,strat=prof,var=varphi_simutegvar2_agtot,
sortie=varphi_simutegvar2_agtot,rep=&rep.,rep2=&rep2.); 
%intval(data=varphiagneuf,strat=prof,var=varphi_simutegvar3_agtot,
sortie=varphi_simutegvar3_agtot,rep=&rep.,rep2=&rep2.); */
%intval(data=varphiagtotalneuf,  strat=,var=varphi_simutc_agtot,
sortie=varphi_simutc_agtot,rep=&rep.,rep2=&rep2.); 
%intval(data=varphiagtotalneuf,  strat=,var=varphi_simutcontop_agtot,
sortie=varphi_simutcontop_agtot,rep=&rep.,rep2=&rep2.); /*
%intval(data=varphiagneuf,strat=prof,var=varphi_simutcvar1_agtot,
sortie=varphi_simutcvar1_agtot,rep=&rep.,rep2=&rep2.); 
%intval(data=varphiagneuf,strat=prof,var=varphi_simutcvar2_agtot,
sortie=varphi_simutcvar2_agtot,rep=&rep.,rep2=&rep2.); 
%intval(data=varphiagneuf,strat=prof,var=varphi_simutcvar3_agtot,
sortie=varphi_simutcvar3_agtot,rep=&rep.,rep2=&rep2.); */

%intval(data=varphiagtotalneufco2,  strat=,var=varphico2_pe_agtot,
sortie =varphic02_pe_agtot,rep=&rep.,rep2=&rep2.);
%intval(data=varphiagtotalneufco2,  strat=,var=varphico2_simutaxdiesel_agtot,
sortie=varphic02_simutaxdiesel_agtot,rep=&rep.,rep2=&rep2.); 
%intval(data=varphiagtotalneufco2,  strat=,var=varphico2_simutc_agtot,
sortie=varphic02_simutc_agtot,rep=&rep.,rep2=&rep2.); 
%intval(data=varphiagtotalneufco2,  strat=,var=varphico2_simutcontop_agtot,
sortie=varphic02_simutcontop_agtot,rep=&rep.,rep2=&rep2.); 

%intval(data=varphiagtotalneufco2,  strat=,var=varphico2_simutegvar1_agtot,
sortie=varphico2_simutegvar1_agtot,rep=&rep.,rep2=&rep2.); 
/*
%intval(data=varphiagneufco2,strat=prof,var=varphico2_simutegvar2_agtot,
sortie=VARPHIC02_SIMUTegVAR2_AGTOT,rep=&rep.,rep2=&rep2.); 
%intval(data=varphiagneufco2,strat=prof,var=varphico2_simutegvar3_agtot,
sortie=varphico2_simutegvar3_agtot,rep=&rep.,rep2=&rep2.);  
 *//*
%intval(data=varphiagneufco2,strat=prof,var=varphico2_simutcvar1_agtot,
sortie=varphico2_simutcvar1_agtot,rep=&rep.,rep2=&rep2.); 

%intval(data=varphiagneufco2,strat=prof,var=varphico2_simutcvar2_agtot,
sortie=VARPHIC02_SIMUTCVAR2_AGTOT,rep=&rep.,rep2=&rep2.); 
%intval(data=varphiagneufco2,strat=prof,var=varphico2_simutcvar3_agtot,
sortie=varphico2_simutcvar3_agtot,rep=&rep.,rep2=&rep2.);  
 */

%intval(data=partsdieseltotalneuf,  strat=,var=PId_peht_agtot,
sortie=PId_peht_agtot,rep=&rep.,rep2=&rep2.);
%intval(data=partsdieseltotalneuf,  strat=,var=PId_simutaxdiesel_agtot,
sortie=PId_simutaxdiesel_agtot,rep=&rep.,rep2=&rep2.); 
%intval(data=partsdieseltotalneuf,  strat=,var=PId_simutegvar1_agtot,
sortie=PId_simutegvar1_agtot,rep=&rep.,rep2=&rep2.); /*
%intval(data=partsdieselneuf,strat=prof,var=PId_simutegvar2_agtot,
sortie=PId_simutegvar2_agtot,rep=&rep.,rep2=&rep2.); 
%intval(data=partsdieselneuf,strat=prof,var=PId_simutegvar3_agtot,
sortie=PId_simutegvar3_agtot,rep=&rep.,rep2=&rep2.);  */
%intval(data=partsdieseltotalneuf,  strat=,var=PId_simutc_agtot,
sortie=PId_simutc_agtot,rep=&rep.,rep2=&rep2.); 
%intval(data=partsdieseltotalneuf,  strat=,var=PId_simutcontop_agtot,
sortie=PId_simutcontop_agtot,rep=&rep.,rep2=&rep2.); /*
%intval(data=partsdieselneuf,strat=prof,var=PId_simutcvar1_agtot,
sortie=PId_simutcvar1_agtot,rep=&rep.,rep2=&rep2.); 
%intval(data=partsdieselneuf,strat=prof,var=PId_simutcvar2_agtot,
sortie=PId_simutcvar2_agtot,rep=&rep.,rep2=&rep2.); 
%intval(data=partsdieselneuf,strat=prof,var=PId_simutcvar3_agtot,
sortie=PId_simutcvar3_agtot,rep=&rep.,rep2=&rep2.);  */

data temp;
merge varphi_simutaxdiesel_agtot 
varphi_simutegvar1_agtot/*
varphi_simutegvar2_agtot
varphi_simutegvar3_agtot*/
varphi_simutc_agtot  
varphi_simutcontop_agtot  /*
varphi_simutcvar1_agtot
varphi_simutcvar2_agtot
varphi_simutcvar3_agtot*/
varphi_pe_agtot 
varphic02_simutaxdiesel_agtot 
varphico2_simutegvar1_agtot/*
VARPHIC02_SIMUTegVAR2_AGTOT
varphico2_simutegvar3_agtot*/
varphic02_simutc_agtot 
varphic02_simutcontop_agtot/*
varphico2_simutcvar1_agtot
VARPHIC02_SIMUTCVAR2_AGTOT
varphico2_simutcvar3_agtot*/
varphic02_pe_agtot 
PId_simutaxdiesel_agtot 
PId_simutegvar1_agtot/*
PId_simutegvar2_agtot
PId_simutegvar3_agtot*/
PId_simutc_agtot 
PId_simutcontop_agtot/*
PId_simutcvar1_agtot
PId_simutcvar2_agtot
PId_simutcvar3_agtot*/
PId_peht_agtot 
;

by var;run;
 
proc export DATA=temp
OUTFILE="\\ulysse\users\givord\@Encours\Petrole\sortiestemporaires\&tab_elast..csv"  
DBMS=csv replace; run;
 
data exemples;merge elast_exemples1 elast_exemples2
elast_exemples2a/*
elast_exemples2b
elast_exemples2c*/
elast_exemples3
elast_exemples3ot/*
elast_exemples3a
elast_exemples3b
elast_exemples3c*/
elast_exemples4 elast_exemples5 ;
by var;run;
proc export DATA=exemples
OUTFILE="\\ulysse\users\givord\@Encours\Petrole\sortiestemporaires\&tab_elast_exemple..csv"  
DBMS=csv replace; run;
  
proc delete data=exemples ;
proc delete data=temp ;run;
 
proc delete data=out ;run;
%mend;    
  
 
